unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
	Button1: TButton;
	Memo1: TMemo;
	Button2: TButton;
	Button3: TButton;
	procedure Button1Click(Sender: TObject);
	procedure Button2Click(Sender: TObject);
	procedure Button3Click(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
	{ Private ̺ Ǵ ϺԴϴ. first class second class ֽϴ.}
  public
	{ Public ̶ Դϴ. ٿ pub. մϴ.}
  end;

var
  Form1: TForm1;

implementation

uses
	UAsmSprite, UFrameBuffer, USpriteData;

{$R *.DFM}

////////////////////////////////////////////////////////////////////////////////
// Implementation of TForm1
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.Button1Click(Sender: TObject);
var
	FrameBuffer: TFrameBuffer;
	i, x, y, w, h: integer;
begin
	FrameBuffer := TFrameBuffer.Create(320, 240);

	w := PSpriteData(@DrawSpriteAir)^.width;
	h := PSpriteData(@DrawSpriteAir)^.height;
	Randomize();
	for i := 0 to 10000 do begin
		x := Random(FrameBuffer.Width - w);
		y := Random(FrameBuffer.Height - h);
		FrameBuffer.DrawImage(x, y, DrawSpriteAir);
	end;

	FrameBuffer.Flush(Canvas, 0, 0);
	FrameBuffer.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
	bgImage: TBitmap;
	spriteCode: TAssembledSprite;
begin
	bgImage := TBitmap.Create;
	bgImage.LoadFromFile('./test.bmp');
	bgImage.PixelFormat := pf15Bit;

	spriteCode := TAssembledSprite.Create(bgImage, 'Air', $001F);
	Memo1.Lines.Assign(spriteCode.spriteCode);
	spriteCode.Free;

	bgImage.Free;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
	FrameBuffer: TFrameBuffer;
	bgImage: TBitmap;
	i, x, y, w, h: integer;
begin
	FrameBuffer := TFrameBuffer.Create(320, 240);

	bgImage := TBitmap.Create;
	bgImage.LoadFromFile('./test.bmp');
	bgImage.PixelFormat := pf15Bit;

	w := bgImage.Width;
	h := bgImage.Height;
	Randomize();
	for i := 0 to 10000 do begin
		x := Random(FrameBuffer.Width - w);
		y := Random(FrameBuffer.Height - h);
		FrameBuffer.DrawImage(x, y, bgImage, $001F);
	end;

	bgImage.Free;

	FrameBuffer.Flush(Canvas, 0, 0);
	FrameBuffer.Free;
end;

procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
	if (ssCtrl in Shift) and (Key = ord('A')) then
		Memo1.SelectAll();
end;

end.

