unit USpriteData;

interface

type
	PSpriteData = ^TSpriteData;
	TSpriteData = packed record
		jumpCode : word;
		width    : longint;
		height   : longint;
		data     : array[0..0] of byte;
	end;

procedure DrawSpriteAir(const pAddr: pointer; const pitch: longint); register; assembler;

implementation

////////////////////////////////////////////////////////////////////////////////
// Assembled sprite data begin
////////////////////////////////////////////////////////////////////////////////

procedure DrawSpriteAir(const pAddr: pointer; const pitch: longint); register; assembler;
asm
	jmp  @@START
	dd   $00000050, $0000008A

@@START:
	push edi
	push esi

	mov  edi, eax
	sub  edx, 80*2

	add  edi, 80*2

	add  edi, edx

	add  edi, 40*2

	lea  esi, @@DATA000000
	mov  ecx, 3
	rep  movsw

	add  edi, 37*2

	add  edi, edx

	add  edi, 39*2

	lea  esi, @@DATA000001
	mov  ecx, 5
	rep  movsw

	add  edi, 36*2

	add  edi, edx

	add  edi, 38*2

	lea  esi, @@DATA000002
	mov  ecx, 7
	rep  movsw

	add  edi, 35*2

	add  edi, edx

	add  edi, 35*2

	lea  esi, @@DATA000003
	mov  ecx, 11
	rep  movsw

	add  edi, 34*2

	add  edi, edx

	add  edi, 35*2

	lea  esi, @@DATA000004
	mov  ecx, 12
	rep  movsw

	add  edi, 5*2

	lea  esi, @@DATA000005
	mov  ecx, 1
	rep  movsw

	add  edi, 27*2

	add  edi, edx

	add  edi, 35*2

	lea  esi, @@DATA000006
	mov  ecx, 12
	rep  movsw

	add  edi, 2*2

	lea  esi, @@DATA000007
	mov  ecx, 5
	rep  movsw

	add  edi, 26*2

	add  edi, edx

	add  edi, 35*2

	lea  esi, @@DATA000008
	mov  ecx, 20
	rep  movsw

	add  edi, 25*2

	add  edi, edx

	add  edi, 36*2

	lea  esi, @@DATA000009
	mov  ecx, 20
	rep  movsw

	add  edi, 24*2

	add  edi, edx

	add  edi, 36*2

	lea  esi, @@DATA000010
	mov  ecx, 21
	rep  movsw

	add  edi, 23*2

	add  edi, edx

	add  edi, 36*2

	lea  esi, @@DATA000011
	mov  ecx, 22
	rep  movsw

	add  edi, 22*2

	add  edi, edx

	add  edi, 36*2

	lea  esi, @@DATA000012
	mov  ecx, 22
	rep  movsw

	add  edi, 22*2

	add  edi, edx

	add  edi, 36*2

	lea  esi, @@DATA000013
	mov  ecx, 26
	rep  movsw

	add  edi, 18*2

	add  edi, edx

	add  edi, 33*2

	lea  esi, @@DATA000014
	mov  ecx, 29
	rep  movsw

	add  edi, 18*2

	add  edi, edx

	add  edi, 32*2

	lea  esi, @@DATA000015
	mov  ecx, 31
	rep  movsw

	add  edi, 17*2

	add  edi, edx

	add  edi, 29*2

	lea  esi, @@DATA000016
	mov  ecx, 34
	rep  movsw

	add  edi, 17*2

	add  edi, edx

	add  edi, 28*2

	lea  esi, @@DATA000017
	mov  ecx, 36
	rep  movsw

	add  edi, 16*2

	add  edi, edx

	add  edi, 27*2

	lea  esi, @@DATA000018
	mov  ecx, 38
	rep  movsw

	add  edi, 15*2

	add  edi, edx

	add  edi, 26*2

	lea  esi, @@DATA000019
	mov  ecx, 42
	rep  movsw

	add  edi, 12*2

	add  edi, edx

	add  edi, 26*2

	lea  esi, @@DATA000020
	mov  ecx, 42
	rep  movsw

	add  edi, 12*2

	add  edi, edx

	add  edi, 25*2

	lea  esi, @@DATA000021
	mov  ecx, 46
	rep  movsw

	add  edi, 9*2

	add  edi, edx

	add  edi, 24*2

	lea  esi, @@DATA000022
	mov  ecx, 49
	rep  movsw

	add  edi, 7*2

	add  edi, edx

	add  edi, 23*2

	lea  esi, @@DATA000023
	mov  ecx, 51
	rep  movsw

	add  edi, 6*2

	add  edi, edx

	add  edi, 22*2

	lea  esi, @@DATA000024
	mov  ecx, 55
	rep  movsw

	add  edi, 3*2

	add  edi, edx

	add  edi, 21*2

	lea  esi, @@DATA000025
	mov  ecx, 57
	rep  movsw

	add  edi, 2*2

	add  edi, edx

	add  edi, 21*2

	lea  esi, @@DATA000026
	mov  ecx, 57
	rep  movsw

	add  edi, 2*2

	add  edi, edx

	add  edi, 21*2

	lea  esi, @@DATA000027
	mov  ecx, 58
	rep  movsw

	add  edi, 1*2

	add  edi, edx

	add  edi, 19*2

	lea  esi, @@DATA000028
	mov  ecx, 60
	rep  movsw

	add  edi, 1*2

	add  edi, edx

	add  edi, 18*2

	lea  esi, @@DATA000029
	mov  ecx, 61
	rep  movsw

	add  edi, 1*2

	add  edi, edx

	add  edi, 17*2

	lea  esi, @@DATA000030
	mov  ecx, 63
	rep  movsw

	add  edi, edx

	add  edi, 17*2

	lea  esi, @@DATA000031
	mov  ecx, 63
	rep  movsw

	add  edi, edx

	add  edi, 16*2

	lea  esi, @@DATA000032
	mov  ecx, 64
	rep  movsw

	add  edi, edx

	add  edi, 15*2

	lea  esi, @@DATA000033
	mov  ecx, 65
	rep  movsw

	add  edi, edx

	add  edi, 15*2

	lea  esi, @@DATA000034
	mov  ecx, 65
	rep  movsw

	add  edi, edx

	add  edi, 14*2

	lea  esi, @@DATA000035
	mov  ecx, 66
	rep  movsw

	add  edi, edx

	add  edi, 14*2

	lea  esi, @@DATA000036
	mov  ecx, 66
	rep  movsw

	add  edi, edx

	add  edi, 14*2

	lea  esi, @@DATA000037
	mov  ecx, 64
	rep  movsw

	add  edi, 2*2

	add  edi, edx

	add  edi, 13*2

	lea  esi, @@DATA000038
	mov  ecx, 65
	rep  movsw

	add  edi, 2*2

	add  edi, edx

	add  edi, 13*2

	lea  esi, @@DATA000039
	mov  ecx, 65
	rep  movsw

	add  edi, 2*2

	add  edi, edx

	add  edi, 13*2

	lea  esi, @@DATA000040
	mov  ecx, 64
	rep  movsw

	add  edi, 3*2

	add  edi, edx

	add  edi, 13*2

	lea  esi, @@DATA000041
	mov  ecx, 64
	rep  movsw

	add  edi, 3*2

	add  edi, edx

	add  edi, 13*2

	lea  esi, @@DATA000042
	mov  ecx, 63
	rep  movsw

	add  edi, 4*2

	add  edi, edx

	add  edi, 13*2

	lea  esi, @@DATA000043
	mov  ecx, 63
	rep  movsw

	add  edi, 4*2

	add  edi, edx

	add  edi, 13*2

	lea  esi, @@DATA000044
	mov  ecx, 63
	rep  movsw

	add  edi, 4*2

	add  edi, edx

	add  edi, 13*2

	lea  esi, @@DATA000045
	mov  ecx, 61
	rep  movsw

	add  edi, 6*2

	add  edi, edx

	add  edi, 12*2

	lea  esi, @@DATA000046
	mov  ecx, 61
	rep  movsw

	add  edi, 7*2

	add  edi, edx

	add  edi, 11*2

	lea  esi, @@DATA000047
	mov  ecx, 61
	rep  movsw

	add  edi, 8*2

	add  edi, edx

	add  edi, 11*2

	lea  esi, @@DATA000048
	mov  ecx, 63
	rep  movsw

	add  edi, 6*2

	add  edi, edx

	add  edi, 11*2

	lea  esi, @@DATA000049
	mov  ecx, 63
	rep  movsw

	add  edi, 6*2

	add  edi, edx

	add  edi, 11*2

	lea  esi, @@DATA000050
	mov  ecx, 63
	rep  movsw

	add  edi, 6*2

	add  edi, edx

	add  edi, 12*2

	lea  esi, @@DATA000051
	mov  ecx, 62
	rep  movsw

	add  edi, 6*2

	add  edi, edx

	add  edi, 12*2

	lea  esi, @@DATA000052
	mov  ecx, 64
	rep  movsw

	add  edi, 4*2

	add  edi, edx

	add  edi, 13*2

	lea  esi, @@DATA000053
	mov  ecx, 64
	rep  movsw

	add  edi, 3*2

	add  edi, edx

	add  edi, 13*2

	lea  esi, @@DATA000054
	mov  ecx, 64
	rep  movsw

	add  edi, 3*2

	add  edi, edx

	add  edi, 11*2

	lea  esi, @@DATA000055
	mov  ecx, 66
	rep  movsw

	add  edi, 3*2

	add  edi, edx

	add  edi, 10*2

	lea  esi, @@DATA000056
	mov  ecx, 67
	rep  movsw

	add  edi, 3*2

	add  edi, edx

	add  edi, 9*2

	lea  esi, @@DATA000057
	mov  ecx, 68
	rep  movsw

	add  edi, 3*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000058
	mov  ecx, 69
	rep  movsw

	add  edi, 3*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000059
	mov  ecx, 69
	rep  movsw

	add  edi, 3*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000060
	mov  ecx, 69
	rep  movsw

	add  edi, 3*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000061
	mov  ecx, 69
	rep  movsw

	add  edi, 3*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000062
	mov  ecx, 69
	rep  movsw

	add  edi, 3*2

	add  edi, edx

	add  edi, 7*2

	lea  esi, @@DATA000063
	mov  ecx, 70
	rep  movsw

	add  edi, 3*2

	add  edi, edx

	add  edi, 7*2

	lea  esi, @@DATA000064
	mov  ecx, 69
	rep  movsw

	add  edi, 4*2

	add  edi, edx

	add  edi, 7*2

	lea  esi, @@DATA000065
	mov  ecx, 68
	rep  movsw

	add  edi, 5*2

	add  edi, edx

	add  edi, 7*2

	lea  esi, @@DATA000066
	mov  ecx, 68
	rep  movsw

	add  edi, 5*2

	add  edi, edx

	add  edi, 7*2

	lea  esi, @@DATA000067
	mov  ecx, 68
	rep  movsw

	add  edi, 5*2

	add  edi, edx

	add  edi, 7*2

	lea  esi, @@DATA000068
	mov  ecx, 69
	rep  movsw

	add  edi, 4*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000069
	mov  ecx, 67
	rep  movsw

	add  edi, 5*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000070
	mov  ecx, 67
	rep  movsw

	add  edi, 5*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000071
	mov  ecx, 67
	rep  movsw

	add  edi, 5*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000072
	mov  ecx, 67
	rep  movsw

	add  edi, 5*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000073
	mov  ecx, 66
	rep  movsw

	add  edi, 6*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000074
	mov  ecx, 65
	rep  movsw

	add  edi, 7*2

	add  edi, edx

	add  edi, 7*2

	lea  esi, @@DATA000075
	mov  ecx, 66
	rep  movsw

	add  edi, 7*2

	add  edi, edx

	add  edi, 6*2

	lea  esi, @@DATA000076
	mov  ecx, 66
	rep  movsw

	add  edi, 8*2

	add  edi, edx

	add  edi, 5*2

	lea  esi, @@DATA000077
	mov  ecx, 68
	rep  movsw

	add  edi, 7*2

	add  edi, edx

	add  edi, 5*2

	lea  esi, @@DATA000078
	mov  ecx, 68
	rep  movsw

	add  edi, 7*2

	add  edi, edx

	add  edi, 4*2

	lea  esi, @@DATA000079
	mov  ecx, 69
	rep  movsw

	add  edi, 7*2

	add  edi, edx

	add  edi, 3*2

	lea  esi, @@DATA000080
	mov  ecx, 70
	rep  movsw

	add  edi, 7*2

	add  edi, edx

	add  edi, 3*2

	lea  esi, @@DATA000081
	mov  ecx, 69
	rep  movsw

	add  edi, 8*2

	add  edi, edx

	add  edi, 2*2

	lea  esi, @@DATA000082
	mov  ecx, 70
	rep  movsw

	add  edi, 8*2

	add  edi, edx

	add  edi, 2*2

	lea  esi, @@DATA000083
	mov  ecx, 70
	rep  movsw

	add  edi, 8*2

	add  edi, edx

	add  edi, 1*2

	lea  esi, @@DATA000084
	mov  ecx, 71
	rep  movsw

	add  edi, 8*2

	add  edi, edx

	add  edi, 1*2

	lea  esi, @@DATA000085
	mov  ecx, 72
	rep  movsw

	add  edi, 7*2

	add  edi, edx

	add  edi, 1*2

	lea  esi, @@DATA000086
	mov  ecx, 72
	rep  movsw

	add  edi, 7*2

	add  edi, edx

	add  edi, 1*2

	lea  esi, @@DATA000087
	mov  ecx, 72
	rep  movsw

	add  edi, 7*2

	add  edi, edx

	add  edi, 1*2

	lea  esi, @@DATA000088
	mov  ecx, 72
	rep  movsw

	add  edi, 7*2

	add  edi, edx

	add  edi, 1*2

	lea  esi, @@DATA000089
	mov  ecx, 72
	rep  movsw

	add  edi, 7*2

	add  edi, edx

	add  edi, 1*2

	lea  esi, @@DATA000090
	mov  ecx, 2
	rep  movsw

	add  edi, 2*2

	lea  esi, @@DATA000091
	mov  ecx, 68
	rep  movsw

	add  edi, 7*2

	add  edi, edx

	add  edi, 1*2

	lea  esi, @@DATA000092
	mov  ecx, 2
	rep  movsw

	add  edi, 3*2

	lea  esi, @@DATA000093
	mov  ecx, 67
	rep  movsw

	add  edi, 7*2

	add  edi, edx

	add  edi, 1*2

	lea  esi, @@DATA000094
	mov  ecx, 2
	rep  movsw

	add  edi, 3*2

	lea  esi, @@DATA000095
	mov  ecx, 65
	rep  movsw

	add  edi, 9*2

	add  edi, edx

	add  edi, 1*2

	lea  esi, @@DATA000096
	mov  ecx, 1
	rep  movsw

	add  edi, 5*2

	lea  esi, @@DATA000097
	mov  ecx, 63
	rep  movsw

	add  edi, 10*2

	add  edi, edx

	add  edi, 1*2

	lea  esi, @@DATA000098
	mov  ecx, 1
	rep  movsw

	add  edi, 6*2

	lea  esi, @@DATA000099
	mov  ecx, 62
	rep  movsw

	add  edi, 10*2

	add  edi, edx

	add  edi, 9*2

	lea  esi, @@DATA000100
	mov  ecx, 61
	rep  movsw

	add  edi, 10*2

	add  edi, edx

	add  edi, 10*2

	lea  esi, @@DATA000101
	mov  ecx, 60
	rep  movsw

	add  edi, 10*2

	add  edi, edx

	add  edi, 11*2

	lea  esi, @@DATA000102
	mov  ecx, 57
	rep  movsw

	add  edi, 12*2

	add  edi, edx

	add  edi, 12*2

	lea  esi, @@DATA000103
	mov  ecx, 55
	rep  movsw

	add  edi, 13*2

	add  edi, edx

	add  edi, 12*2

	lea  esi, @@DATA000104
	mov  ecx, 55
	rep  movsw

	add  edi, 13*2

	add  edi, edx

	add  edi, 12*2

	lea  esi, @@DATA000105
	mov  ecx, 54
	rep  movsw

	add  edi, 14*2

	add  edi, edx

	add  edi, 12*2

	lea  esi, @@DATA000106
	mov  ecx, 54
	rep  movsw

	add  edi, 14*2

	add  edi, edx

	add  edi, 12*2

	lea  esi, @@DATA000107
	mov  ecx, 53
	rep  movsw

	add  edi, 15*2

	add  edi, edx

	add  edi, 13*2

	lea  esi, @@DATA000108
	mov  ecx, 51
	rep  movsw

	add  edi, 16*2

	add  edi, edx

	add  edi, 10*2

	lea  esi, @@DATA000109
	mov  ecx, 55
	rep  movsw

	add  edi, 15*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000110
	mov  ecx, 57
	rep  movsw

	add  edi, 15*2

	add  edi, edx

	add  edi, 6*2

	lea  esi, @@DATA000111
	mov  ecx, 59
	rep  movsw

	add  edi, 15*2

	add  edi, edx

	add  edi, 5*2

	lea  esi, @@DATA000112
	mov  ecx, 59
	rep  movsw

	add  edi, 16*2

	add  edi, edx

	add  edi, 4*2

	lea  esi, @@DATA000113
	mov  ecx, 61
	rep  movsw

	add  edi, 15*2

	add  edi, edx

	add  edi, 4*2

	lea  esi, @@DATA000114
	mov  ecx, 62
	rep  movsw

	add  edi, 14*2

	add  edi, edx

	add  edi, 4*2

	lea  esi, @@DATA000115
	mov  ecx, 26
	rep  movsw

	add  edi, 1*2

	lea  esi, @@DATA000116
	mov  ecx, 35
	rep  movsw

	add  edi, 14*2

	add  edi, edx

	add  edi, 4*2

	lea  esi, @@DATA000117
	mov  ecx, 26
	rep  movsw

	add  edi, 1*2

	lea  esi, @@DATA000118
	mov  ecx, 36
	rep  movsw

	add  edi, 13*2

	add  edi, edx

	add  edi, 5*2

	lea  esi, @@DATA000119
	mov  ecx, 25
	rep  movsw

	add  edi, 1*2

	lea  esi, @@DATA000120
	mov  ecx, 36
	rep  movsw

	add  edi, 13*2

	add  edi, edx

	add  edi, 5*2

	lea  esi, @@DATA000121
	mov  ecx, 23
	rep  movsw

	add  edi, 1*2

	lea  esi, @@DATA000122
	mov  ecx, 1
	rep  movsw

	add  edi, 1*2

	lea  esi, @@DATA000123
	mov  ecx, 36
	rep  movsw

	add  edi, 13*2

	add  edi, edx

	add  edi, 6*2

	lea  esi, @@DATA000124
	mov  ecx, 22
	rep  movsw

	add  edi, 1*2

	lea  esi, @@DATA000125
	mov  ecx, 1
	rep  movsw

	add  edi, 1*2

	lea  esi, @@DATA000126
	mov  ecx, 36
	rep  movsw

	add  edi, 13*2

	add  edi, edx

	add  edi, 6*2

	lea  esi, @@DATA000127
	mov  ecx, 21
	rep  movsw

	add  edi, 4*2

	lea  esi, @@DATA000128
	mov  ecx, 36
	rep  movsw

	add  edi, 13*2

	add  edi, edx

	add  edi, 7*2

	lea  esi, @@DATA000129
	mov  ecx, 17
	rep  movsw

	add  edi, 5*2

	lea  esi, @@DATA000130
	mov  ecx, 18
	rep  movsw

	add  edi, 1*2

	lea  esi, @@DATA000131
	mov  ecx, 19
	rep  movsw

	add  edi, 13*2

	add  edi, edx

	add  edi, 7*2

	lea  esi, @@DATA000132
	mov  ecx, 16
	rep  movsw

	add  edi, 5*2

	lea  esi, @@DATA000133
	mov  ecx, 18
	rep  movsw

	add  edi, 3*2

	lea  esi, @@DATA000134
	mov  ecx, 18
	rep  movsw

	add  edi, 13*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000135
	mov  ecx, 15
	rep  movsw

	add  edi, 5*2

	lea  esi, @@DATA000136
	mov  ecx, 18
	rep  movsw

	add  edi, 3*2

	lea  esi, @@DATA000137
	mov  ecx, 18
	rep  movsw

	add  edi, 13*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000138
	mov  ecx, 14
	rep  movsw

	add  edi, 6*2

	lea  esi, @@DATA000139
	mov  ecx, 18
	rep  movsw

	add  edi, 4*2

	lea  esi, @@DATA000140
	mov  ecx, 18
	rep  movsw

	add  edi, 12*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000141
	mov  ecx, 12
	rep  movsw

	add  edi, 7*2

	lea  esi, @@DATA000142
	mov  ecx, 20
	rep  movsw

	add  edi, 4*2

	lea  esi, @@DATA000143
	mov  ecx, 16
	rep  movsw

	add  edi, 13*2

	add  edi, edx

	add  edi, 8*2

	lea  esi, @@DATA000144
	mov  ecx, 11
	rep  movsw

	add  edi, 8*2

	lea  esi, @@DATA000145
	mov  ecx, 20
	rep  movsw

	add  edi, 5*2

	lea  esi, @@DATA000146
	mov  ecx, 15
	rep  movsw

	add  edi, 13*2

	add  edi, edx

	add  edi, 9*2

	lea  esi, @@DATA000147
	mov  ecx, 10
	rep  movsw

	add  edi, 8*2

	lea  esi, @@DATA000148
	mov  ecx, 20
	rep  movsw

	add  edi, 6*2

	lea  esi, @@DATA000149
	mov  ecx, 13
	rep  movsw

	add  edi, 14*2

	add  edi, edx

	add  edi, 10*2

	lea  esi, @@DATA000150
	mov  ecx, 8
	rep  movsw

	add  edi, 9*2

	lea  esi, @@DATA000151
	mov  ecx, 20
	rep  movsw

	add  edi, 7*2

	lea  esi, @@DATA000152
	mov  ecx, 11
	rep  movsw

	add  edi, 15*2

	add  edi, edx

	add  edi, 11*2

	lea  esi, @@DATA000153
	mov  ecx, 7
	rep  movsw

	add  edi, 9*2

	lea  esi, @@DATA000154
	mov  ecx, 20
	rep  movsw

	add  edi, 9*2

	lea  esi, @@DATA000155
	mov  ecx, 8
	rep  movsw

	add  edi, 16*2

	add  edi, edx

	add  edi, 12*2

	lea  esi, @@DATA000156
	mov  ecx, 6
	rep  movsw

	add  edi, 9*2

	lea  esi, @@DATA000157
	mov  ecx, 20
	rep  movsw

	add  edi, 33*2

	add  edi, edx

	add  edi, 13*2

	lea  esi, @@DATA000158
	mov  ecx, 4
	rep  movsw

	add  edi, 10*2

	lea  esi, @@DATA000159
	mov  ecx, 20
	rep  movsw

	add  edi, 33*2

	add  edi, edx

	add  edi, 14*2

	lea  esi, @@DATA000160
	mov  ecx, 3
	rep  movsw

	add  edi, 10*2

	lea  esi, @@DATA000161
	mov  ecx, 19
	rep  movsw

	add  edi, 34*2

	add  edi, edx

	add  edi, 27*2

	lea  esi, @@DATA000162
	mov  ecx, 19
	rep  movsw

	add  edi, 34*2

	add  edi, edx

	add  edi, 27*2

	lea  esi, @@DATA000163
	mov  ecx, 19
	rep  movsw

	add  edi, 34*2

	add  edi, edx

	add  edi, 27*2

	lea  esi, @@DATA000164
	mov  ecx, 18
	rep  movsw

	add  edi, 35*2

	add  edi, edx

	add  edi, 27*2

	lea  esi, @@DATA000165
	mov  ecx, 18
	rep  movsw

	add  edi, 35*2

	add  edi, edx

	add  edi, 28*2

	lea  esi, @@DATA000166
	mov  ecx, 16
	rep  movsw

	add  edi, 36*2

	add  edi, edx

	add  edi, 29*2

	lea  esi, @@DATA000167
	mov  ecx, 15
	rep  movsw

	add  edi, 36*2

	add  edi, edx

	add  edi, 29*2

	lea  esi, @@DATA000168
	mov  ecx, 14
	rep  movsw

	add  edi, 37*2

	add  edi, edx

	add  edi, 30*2

	lea  esi, @@DATA000169
	mov  ecx, 12
	rep  movsw

	add  edi, 38*2

	add  edi, edx

	add  edi, 31*2

	lea  esi, @@DATA000170
	mov  ecx, 10
	rep  movsw

	add  edi, 39*2

	add  edi, edx

	add  edi, 32*2

	lea  esi, @@DATA000171
	mov  ecx, 8
	rep  movsw

	add  edi, 40*2

	add  edi, edx

	add  edi, 80*2

	add  edi, edx

	pop  esi
	pop  edi

	ret

@@DATA000000:
	dw   $0843, $0843, $0843
@@DATA000001:
	dw   $1CA4, $66D4, $7F9A, $45CE, $0C63
@@DATA000002:
	dw   $24C5, $7F9A, $7FDF, $7BFE, $7BDE, $5674, $0C63
@@DATA000003:
	dw   $1460, $0C63, $5A71, $7FBA, $7BBD, $7BDD, $7FFF, $7BDD, $7BFF, $5293, $0863
@@DATA000004:
	dw   $0843, $62D5, $7BBD, $7BDD, $7FFF, $7BDD, $737A, $77BD, $77BE, $7BDD, $41F0, $0863
@@DATA000005:
	dw   $4230
@@DATA000006:
	dw   $0843, $5AD6, $7BDD, $7FDF, $7FFF, $739C, $5295, $52B6, $4E94, $4E94, $39AD, $14A5
@@DATA000007:
	dw   $294A, $294A, $5AD6, $7BDD, $66F8
@@DATA000008:
	dw   $1042, $2528, $77BD, $7BFE, $7BBD, $739C, $52B6, $52B6, $5295, $2529, $5F18, $7BDE, $737C, $7BDD, $77BE, $56B5, $4631, $7BFE, $77BD, $56B5
@@DATA000009:
	dw   $0863, $6B5A, $7FFF, $7BFE, $7BDD, $5AF8, $4E74, $5295, $41F0, $294B, $6739, $7BDE, $7FFF, $7BDE, $739C, $5AD7, $77BE, $7BFF, $7BFF, $2D6B
@@DATA000010:
	dw   $0843, $41CF, $77BD, $7BDD, $7FFF, $6B5A, $56D7, $5295, $4E74, $39CE, $39CE, $7BDE, $7BDE, $7FDF, $7BBD, $56B5, $6718, $7BFF, $77BE, $77BD, $1064
@@DATA000011:
	dw   $1042, $1064, $7B9C, $7FDF, $7BDE, $6B9C, $5AF8, $4E74, $5295, $5295, $4A33, $35AE, $7BBD, $7BDE, $7FDF, $56B5, $56B5, $739C, $7BFE, $77BE, $39CE, $0863
@@DATA000012:
	dw   $1C41, $1020, $2D6B, $294B, $2529, $18C7, $1D08, $1CE8, $2529, $358D, $318D, $0863, $1084, $41F0, $6739, $56B5, $5293, $5AD6, $7BDD, $77BD, $77BE, $2529
@@DATA000013:
	dw   $1460, $1CA4, $294A, $4230, $5AF8, $6B7B, $77BD, $6B7B, $7BFE, $6B5A, $56B5, $4A74, $14A6, $0843, $0863, $1D08, $358D, $4210, $5AD6, $7BFE, $77BD, $52B6, $39F0, $77BE, $7BDE, $5F18
@@DATA000014:
	dw   $1CC4, $1CC4, $35AB, $5AB4, $6F39, $739C, $77BE, $7BFE, $77BD, $7BBD, $7BDD, $7BBD, $77BD, $7BFE, $77BD, $737A, $4A31, $0C64, $1084, $0C63, $0C63, $1D08, $4E74, $7FDF, $5F18, $358D, $7BBD, $7BFE, $7BDD
@@DATA000015:
	dw   $18A5, $2D6B, $5AD7, $7BBD, $7BBD, $7BBD, $7BBD, $77BD, $739C, $6B5A, $6718, $6F39, $6F39, $735A, $6B7B, $737A, $779A, $5293, $294B, $56D7, $56D7, $358D, $358D, $358D, $1CE8, $39CE, $20E8, $6F39, $7BBD, $739C, $14A5
@@DATA000016:
	dw   $0C63, $1CC6, $39AD, $6F39, $737C, $6739, $5F18, $5AD6, $5674, $4A31, $2529, $20E8, $2528, $356B, $356B, $356A, $2509, $294A, $2529, $2949, $5271, $7BDD, $7BFF, $7BFF, $739C, $35AE, $41D0, $4A33, $2509, $1CC6, $1CC4, $1CE7, $1CE7, $14C5
@@DATA000017:
	dw   $1084, $14C5, $5293, $737C, $66F8, $4E33, $49D1, $394E, $312D, $312C, $1465, $1CA8, $5ED7, $735C, $735C, $735C, $735C, $735C, $735C, $66F8, $62D8, $739C, $7BFE, $7BFF, $7FDF, $7BDE, $735C, $18A6, $1CE8, $2509, $4631, $5F18, $4210, $18C7, $0C64, $0863
@@DATA000018:
	dw   $1084, $14C5, $5F18, $7BBD, $5674, $49B2, $394F, $310E, $310D, $310D, $1867, $24C9, $2D0C, $394E, $49B3, $41D1, $49D1, $41D1, $49D2, $49D2, $49B2, $4E33, $77BD, $7BFE, $7FDF, $7FDF, $7FDF, $7BDE, $4A33, $2D6B, $739C, $6B7B, $4A33, $739C, $5F18, $358D, $14C5, $0C63
@@DATA000019:
	dw   $0C64, $1D08, $62D8, $66F8, $5634, $4993, $350F, $310D, $350E, $350E, $24C9, $1867, $310E, $350F, $350E, $4993, $4993, $4DD4, $49B3, $49B3, $49B2, $4993, $5A56, $737C, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $739C, $2D6B, $4E33, $49D1, $49B3, $5634, $735C, $739C, $5293, $1CC7, $0863, $0863, $1084
@@DATA000020:
	dw   $358D, $6739, $4E33, $49B3, $4993, $4D94, $4D94, $350E, $350E, $312D, $1867, $350F, $350F, $350E, $350F, $4D94, $49B3, $4DD4, $66F8, $4E33, $49B2, $4993, $5634, $737C, $7FFF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $6739, $354D, $49B2, $49B3, $49B3, $49D2, $6739, $7FDF, $7BDD, $739C, $6718, $4A31
@@DATA000021:
	dw   $396E, $7B9C, $5634, $49B2, $4D94, $4D94, $4D94, $4993, $396E, $312C, $18A6, $24C9, $310D, $350F, $350F, $350F, $49B2, $49B2, $4A33, $7FDF, $7BBD, $4E33, $49D2, $5634, $6B7B, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $5634, $396E, $49B2, $4993, $49B3, $4DD4, $7BDE, $7FDF, $7FDF, $7FFF, $7FFF, $7BBD, $7BDD, $39CE
@@DATA000022:
	dw   $4631, $735C, $5A56, $49B2, $4993, $4D94, $4D94, $4D94, $4993, $49D1, $318D, $1483, $312C, $350E, $350E, $350F, $350F, $4590, $45D1, $4A33, $7BBD, $7FDF, $7BDE, $49D1, $5634, $77BD, $7FDF, $7FDF, $7FDF, $7FDF, $7FFF, $7FDF, $7FDF, $7FDF, $5E76, $41D0, $49B2, $4993, $49D2, $7BDE, $7FDF, $7FDF, $7FDF, $7FDF, $7BFE, $7BFE, $77BD, $77BE, $294A
@@DATA000023:
	dw   $4631, $735C, $4A33, $45D1, $4993, $4D94, $4993, $4D94, $4993, $49B2, $49D1, $1CA8, $2D6B, $312C, $310E, $350E, $350F, $350E, $4171, $49B2, $41D1, $737C, $7FDF, $7FDF, $6F39, $5674, $7BDE, $7FDF, $7FDF, $7FDF, $7FDF, $7BFF, $7BFF, $7FDF, $7FDF, $7BDE, $4631, $2D2B, $45D1, $49D1, $7BDE, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $77BD, $7BDD, $4230
@@DATA000024:
	dw   $2D29, $735C, $41D1, $396E, $394F, $4D94, $4D94, $350F, $310D, $354D, $1CA8, $24C9, $5634, $5674, $358D, $310D, $350F, $350E, $350E, $416F, $49B2, $49D2, $5ED7, $7FDF, $7FDF, $7FDF, $7BBD, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7BFF, $7FDF, $7FDF, $7FDF, $6739, $358D, $2509, $4631, $7BDE, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7BFE, $77BD, $77BD, $2949, $1084
@@DATA000025:
	dw   $1CC5, $5ED7, $49D2, $4171, $350F, $350E, $49B2, $24C9, $1CA8, $2D0C, $28CB, $416F, $5634, $735C, $6739, $4E33, $41D1, $310E, $350E, $350E, $394F, $49B2, $49B2, $62D8, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7BFF, $7FDF, $7FDF, $7FDF, $62D8, $4631, $4A33, $7BDE, $7FDF, $7FDF, $7FDF, $7FFF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FFF, $77BD, $5ED7, $18C7, $14A6
@@DATA000026:
	dw   $4210, $62D8, $49B2, $350F, $350F, $350F, $310E, $28CB, $310D, $310D, $394F, $49D2, $49D1, $66F8, $7BBD, $62D8, $4E33, $4171, $310E, $350E, $350E, $4993, $4DD4, $4E33, $735C, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $6739, $7BDE, $7B9C, $737C, $7BDE, $7FDF, $7FDF, $7FDF, $7BFE, $7BFE, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7BFE, $7BDE, $39CE, $14A6
@@DATA000027:
	dw   $5293, $1064, $1CA8, $310D, $350F, $350F, $2D0C, $310D, $350E, $310D, $394F, $49B2, $49D2, $5634, $737C, $7BDE, $62D8, $49D1, $394F, $350E, $416F, $49B2, $4D94, $49B3, $735A, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $6B5A, $7BFE, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $56B5, $62D8, $7BBD, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FFF, $7FFF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $77BE, $77BE, $1CE8, $18C7
@@DATA000028:
	dw   $0C63, $35AB, $5AF8, $5295, $18A5, $2D0B, $354D, $310D, $394F, $350E, $310D, $350F, $310D, $49B3, $49B3, $49B2, $6718, $7B9C, $7B9C, $62D8, $49D2, $310D, $350E, $4DD4, $4D94, $49B3, $66F8, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $6718, $5AD6, $737A, $7FDF, $7FDF, $7FDF, $7FDF, $7BDE, $358D, $739C, $7FDF, $7FDF, $7FDF, $7FFF, $7FDF, $7FDF, $7BFE, $7BFE, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $77BD, $39CE, $1084
@@DATA000029:
	dw   $14A6, $35AB, $7BDD, $7BFE, $7FFF, $4A2F, $1CA4, $312C, $24C9, $394F, $310E, $350F, $310D, $350F, $4DD4, $4993, $49B3, $5E76, $7B9C, $7BDE, $739C, $4E33, $394F, $310D, $4993, $4993, $4993, $5634, $737C, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7BDE, $358D, $4631, $6718, $7FDF, $7FDF, $7FDF, $7FDF, $6718, $2529, $7BFE, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FFF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $739C, $14C5
@@DATA000030:
	dw   $18C7, $14A6, $6735, $7BDD, $7FFF, $7BFE, $7BDD, $3569, $39AD, $2D0B, $49B3, $350F, $350E, $350E, $4171, $4993, $4D94, $4DD4, $49D1, $6F39, $7BBD, $7BDE, $62D8, $312C, $312D, $49B3, $4DD4, $4993, $45D1, $66F8, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7BDE, $4631, $1CC5, $4A31, $6718, $7FDF, $7FDF, $7FDF, $7FDF, $2D6B, $4210, $77BE, $7FDF, $7FDF, $7FDF, $7FDF, $7BFE, $7BFE, $7BDE, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7BDD, $1CE7, $18C7
@@DATA000031:
	dw   $0863, $4E94, $5772, $77F7, $7FFF, $7FFF, $7FBA, $7777, $2905, $41CF, $49D2, $310E, $350E, $350E, $4171, $4DD4, $4D94, $4D94, $45D1, $5ED7, $7BDE, $7BBD, $7BBD, $1CA8, $1064, $394F, $49D2, $49B3, $49B2, $49D2, $735C, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $4E33, $312C, $20E8, $4E33, $6718, $7FDF, $7FDF, $7FDF, $77BD, $1D08, $5ED7, $7FDF, $7FDF, $7FDF, $7FDF, $7BFE, $77BD, $6739, $737C, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $2D6B, $1084
@@DATA000032:
	dw   $0863, $35F1, $53BA, $57B2, $6FF5, $7FFF, $7FFF, $7FBA, $77F7, $24C5, $356A, $4590, $4171, $350E, $350E, $4D94, $4993, $4D94, $4D94, $49B3, $5634, $735A, $7BDE, $7BBD, $56B5, $14A6, $1CA8, $416F, $49B2, $49B3, $49B3, $5634, $737C, $7FDF, $7FDF, $7FDF, $7FDF, $5E76, $41D0, $1CA8, $354D, $4631, $6718, $7FDF, $7FDF, $7BDD, $2528, $39F0, $7FDF, $7FDF, $7FDF, $7FDF, $7FDF, $77BD, $4210, $5674, $6276, $7BBD, $7FDF, $7FDF, $7FDF, $7BFE, $318D, $14A6
@@DATA000033:
	dw   $0C63, $2529, $639E, $53BA, $6FF5, $6FF5, $7FFF, $7FFF, $7FBA, $77F7, $24C5, $41CD, $49B2, $4171, $350E, $350E, $4DD4, $350F, $4171, $4D94, $49B3, $49D1, $5674, $7B9C, $7BDE, $7BDE, $35AE, $1064, $24C9, $45D1, $4993, $4993, $49B2, $6276, $7FDF, $7FDF, $7FDF, $7FDF, $5674, $49D1, $416F, $1CA8, $4A31, $5674, $6F39, $7BBD, $5293, $1CE7, $18A6, $739C, $7FDF, $7FDF, $7FDF, $7FDF, $739C, $2D6B, $45D1, $45D1, $5E76, $7FDF, $7FDF, $7FDF, $7BFE, $39CE, $1084
@@DATA000034:
	dw   $0C63, $6B9C, $7BFF, $6B9C, $5772, $77F7, $7BDD, $7FFF, $7FBA, $7777, $1CA4, $416F, $49B2, $4D94, $350E, $350F, $5634, $350E, $350F, $4D94, $4993, $49B2, $49D1, $62D8, $7FDF, $77BD, $77BD, $14A5, $0843, $41D0, $4993, $4D94, $49B3, $45D1, $6739, $7FDF, $7FDF, $7FDF, $5E76, $49D1, $49B2, $312D, $394E, $41CF, $5ED7, $4A31, $14C5, $14C5, $18C7, $4631, $6718, $7BBD, $7FDF, $7FDF, $737C, $312C, $4590, $49B2, $49D1, $6739, $7FDF, $7FDF, $7FDF, $39CE, $1084
@@DATA000035:
	dw   $14A5, $39CE, $7BFF, $639E, $53BA, $3E91, $6B5A, $7BFE, $7FFF, $7BDD, $5AB4, $1867, $4171, $4993, $4993, $310E, $350E, $5634, $312C, $350E, $4D94, $4D94, $4D94, $49B3, $49D2, $735C, $7BDE, $7BDE, $35AE, $18A5, $2509, $4993, $4DD4, $49B2, $394E, $49D2, $7BDE, $7FDF, $7FDF, $6276, $4590, $4DD4, $310E, $24C9, $49D1, $41D0, $41CF, $35AB, $4A31, $358D, $1465, $45D1, $5E76, $7BBD, $7FDF, $737C, $312C, $394E, $49B3, $49B2, $4E33, $7BBD, $7FDF, $7FDF, $35AB, $1483
@@DATA000036:
	dw   $0863, $56D7, $53BA, $3EF9, $3676, $216E, $4231, $7FFF, $7BFE, $7BDD, $2D29, $1867, $4993, $4993, $28CB, $350F, $2D0C, $5634, $394E, $2D0C, $4993, $4D94, $4D94, $4D94, $49B3, $6276, $7BDE, $7BDE, $739C, $1CC6, $1465, $394F, $4993, $45D1, $354D, $312D, $5ED7, $7FDF, $7FDF, $66F8, $49B2, $4DD4, $350F, $1465, $49D1, $49D2, $5634, $6F39, $7BBD, $4631, $1465, $45D1, $49D1, $56B5, $7B9C, $6718, $312D, $394F, $4993, $4993, $49B3, $5634, $7FDF, $7BBD, $2528, $14A5
@@DATA000037:
	dw   $1509, $1617, $1639, $1639, $1639, $156F, $4EB7, $7FFF, $7FFF, $77BE, $1CC7, $28E8, $4590, $4590, $1CA8, $394F, $2D0C, $5674, $5674, $2D0B, $4DD4, $4D94, $4D94, $4D94, $4DD4, $49D2, $735C, $7BDE, $7BBD, $4631, $1064, $24C9, $41D1, $45D1, $394E, $2D0C, $394F, $7BDE, $7FDF, $5E76, $49B3, $4993, $4D94, $1867, $4590, $4993, $49B2, $62D8, $7B9C, $66F8, $1867, $312C, $4590, $4E33, $735C, $62D8, $2D0C, $4D94, $4D94, $4DD4, $4993, $49D1, $7BDE, $737C
@@DATA000038:
	dw   $0863, $25B3, $1639, $0A1A, $0A1A, $1639, $08EB, $6B7B, $77BE, $7BFF, $739C, $1064, $28E8, $4590, $416F, $1465, $4171, $312D, $5674, $6718, $1CA8, $49B3, $4D94, $4D94, $4D94, $4993, $41D1, $39CE, $4631, $77BD, $6B5A, $2529, $1867, $49D2, $45D1, $394E, $310D, $310E, $4A33, $735C, $62D8, $49B3, $4D94, $4993, $1465, $28CB, $4993, $49B3, $4E33, $6718, $5AD7, $1465, $28CB, $45D1, $45D1, $6276, $5E76, $24C9, $4993, $4D94, $4D94, $4993, $49D1, $7BDE, $4210
@@DATA000039:
	dw   $0843, $1617, $1639, $0A1A, $0A1A, $1617, $216E, $56D7, $56D7, $5F18, $737C, $14A6, $354D, $4590, $312D, $1064, $394F, $312D, $4E33, $735A, $28E8, $416F, $4D94, $4D94, $49B3, $312D, $1064, $0842, $14C5, $4A74, $7BBD, $4A33, $1CA8, $312D, $49B2, $394F, $350F, $350F, $2D0C, $49D2, $5A56, $4993, $4D94, $4DD4, $1CA8, $1CE8, $49D1, $416F, $14A6, $0863, $14C5, $1064, $24C6, $4590, $49B2, $5634, $49D2, $1CA8, $49B2, $4D94, $4D94, $4993, $49D1, $7BDE, $358D
@@DATA000040:
	dw   $0863, $1617, $0A1A, $0A1A, $0A1A, $11B3, $21B1, $4E74, $4EB7, $56D7, $4A74, $18A5, $49B3, $49B3, $312D, $1465, $49B2, $312D, $4A33, $735C, $2D2B, $354D, $4993, $4993, $28CB, $1064, $1CA8, $318D, $4631, $737C, $7BBD, $56B5, $2509, $18A6, $49D1, $416F, $350F, $350F, $350F, $310E, $49B3, $4DD4, $4D94, $4993, $28CB, $18A6, $41D0, $1CA8, $0421, $0C64, $0C63, $0C63, $28E8, $416F, $49B2, $49B3, $49D1, $1064, $49B3, $4D94, $4D94, $4DD4, $5E76, $7B9C
@@DATA000041:
	dw   $0863, $1617, $0A1A, $0A1A, $1639, $052F, $4E74, $52B6, $52B6, $4EB7, $4631, $1465, $4590, $49B3, $394F, $1465, $4590, $312C, $45D1, $6739, $41CF, $1CA8, $49D2, $350E, $24C9, $416F, $49B2, $49B2, $45D1, $66F8, $7BBD, $737A, $2529, $18A6, $312C, $416F, $350E, $350F, $350F, $310E, $2D0C, $4590, $4D94, $4D94, $2D0C, $1CA8, $356B, $0C63, $0C64, $0843, $0843, $1064, $312C, $350E, $4D94, $4993, $354D, $1064, $4993, $4D94, $4D94, $4993, $66F8, $35AB
@@DATA000042:
	dw   $0C64, $1617, $0A1A, $0A1A, $0DB6, $052F, $4E74, $52B6, $4EB7, $4E94, $318D, $1063, $394F, $49B3, $41D1, $1465, $45D1, $416F, $396E, $6718, $62D8, $18A6, $354D, $2D0B, $4993, $4993, $4DD4, $4DD4, $4590, $5634, $7BBD, $7B9C, $4210, $1064, $1CE8, $49B2, $350E, $350F, $350F, $350F, $354D, $4590, $4993, $4993, $2D0C, $1064, $1CC7, $0C63, $14E8, $0C64, $0C64, $1064, $310D, $350E, $4D94, $4DD4, $20E8, $1064, $4DD4, $4D94, $4D94, $49B3, $735C
@@DATA000043:
	dw   $0863, $1617, $0A1A, $0A1A, $11B3, $156F, $4E94, $5295, $4E74, $4EB7, $18C7, $1063, $2D0C, $49B3, $49D1, $1465, $416F, $416F, $356B, $5AF8, $77BD, $1D08, $1063, $416F, $4D94, $4D94, $4DD4, $354D, $2509, $312C, $62D8, $7BDE, $6B5A, $1084, $1867, $49D2, $4171, $350F, $350F, $310E, $350E, $4171, $4D94, $49B3, $1064, $18A6, $2D6B, $0842, $31AD, $31AD, $0863, $0C64, $312D, $350E, $4DD4, $49B2, $1064, $1064, $4D94, $4D94, $4DD4, $4DD4, $41D0
@@DATA000044:
	dw   $0C64, $1172, $0A1A, $1639, $052F, $3676, $4EB7, $4EB7, $4EB7, $4231, $20E8, $18A6, $28CB, $4993, $49D1, $1465, $4590, $4590, $312C, $41F0, $6B7B, $358D, $1063, $354D, $4DD4, $4DD4, $4171, $294C, $1064, $0863, $2509, $7BBD, $7BDD, $2949, $1063, $312D, $4DD4, $4993, $394F, $350F, $350E, $49B2, $49B3, $312D, $1064, $318D, $2D6B, $0863, $5F18, $6B9C, $0C85, $0C64, $2D0B, $354D, $49B2, $28CB, $1064, $24C9, $4DD4, $4D94, $49B3, $394E, $1465
@@DATA000045:
	dw   $0863, $1172, $1617, $11B3, $3213, $4EB7, $52B6, $4E94, $56D7, $14E8, $2509, $20E8, $28CB, $49B3, $49D1, $1465, $4171, $4993, $2D0C, $396E, $6718, $62D8, $2509, $18A6, $41D0, $312D, $312D, $2509, $0843, $0C64, $0C64, $5AD6, $7BDD, $39CE, $1CC7, $1CA8, $4993, $4D94, $4993, $4171, $416F, $49B2, $416F, $1465, $24C6, $62D5, $41F0, $0843, $0CE8, $216E, $0CE8, $150B, $0C85, $2509, $49D1, $1465, $1064, $354D, $49B2, $394E, $20E8
@@DATA000046:
	dw   $0C63, $0843, $3213, $11B3, $052F, $639E, $56B5, $5295, $52B6, $4E74, $14A6, $2D2B, $1CA8, $24C9, $49B3, $49D1, $1465, $350F, $4D94, $312D, $396E, $5674, $7BDE, $318D, $4631, $18C7, $20E8, $18A6, $0C64, $14E8, $0465, $0465, $18C7, $739C, $5293, $2D6B, $2509, $49B2, $4993, $4993, $49B3, $49B2, $4590, $1CA8, $39AD, $356A, $62D5, $1D08, $0C64, $0CEA, $08EB, $112D, $216E, $39F0, $312D, $28E8, $1465, $0843, $41D0, $45D1, $1CA8
@@DATA000047:
	dw   $2949, $0C63, $0843, $112D, $156F, $3EF9, $77BE, $7BBD, $5F18, $5F18, $35AE, $18A6, $312C, $1CA8, $1867, $49D2, $49B2, $1867, $350E, $4993, $394E, $358D, $41F0, $77BE, $4231, $4231, $18C7, $1084, $0C64, $0CE8, $0CEA, $08EB, $0CEA, $0CA7, $31AD, $6739, $35AB, $356B, $28E8, $4590, $49B3, $49B2, $41CD, $24C6, $45CE, $356B, $356A, $2927, $5F18, $10C7, $0CEA, $04ED, $052F, $08EB, $0CA7, $294A, $2529, $1CC7, $1CC7, $2D6B, $1483
@@DATA000048:
	dw   $14A5, $318D, $1D08, $0CEA, $4EB7, $639E, $7BBD, $7FDF, $7BBD, $6739, $2529, $318D, $312D, $1CA8, $0843, $49D1, $49B2, $1867, $28CB, $49D2, $396E, $312C, $318D, $5F18, $77BE, $31AD, $18C7, $0C64, $0C85, $0CEA, $3213, $3213, $08EB, $0CEA, $10C7, $4A74, $2506, $45CE, $28E8, $45D1, $4590, $49D1, $24C3, $49CB, $6F39, $356B, $356A, $66F8, $6B5A, $294B, $08EB, $04ED, $1172, $156F, $0CA7, $18C7, $5AD7, $2528, $294A, $0C63, $0421, $0C63, $0821
@@DATA000049:
	dw   $18C7, $4210, $5F3B, $0CE8, $4E74, $77BE, $7FFF, $7BDD, $6B5A, $1CC7, $358D, $354D, $2D0B, $2D0C, $0843, $394E, $49D2, $1CA8, $1064, $4590, $49B3, $350E, $312C, $5634, $739C, $2D2B, $0C64, $0465, $0CE8, $150B, $77BE, $639E, $0CEA, $0465, $294B, $5AD6, $2506, $5A71, $24A2, $45CE, $41CD, $24C6, $49CB, $72F4, $7379, $735A, $735A, $735A, $6B5A, $35AE, $08EB, $04ED, $11B3, $04ED, $216E, $6739, $7BDD, $2949, $0843, $1064, $0C63, $294A, $1CE8
@@DATA000050:
	dw   $14A5, $18A5, $7BFF, $5295, $18C7, $39CE, $7B9C, $7B9C, $35AE, $5674, $358D, $358D, $354D, $312C, $0843, $312D, $416F, $2D0B, $1064, $312C, $4993, $350F, $312D, $354D, $5634, $18C7, $0C85, $0CA7, $0CEA, $0CEA, $4233, $4EB7, $0CEA, $0465, $14A6, $4A31, $24C3, $5E91, $3907, $3907, $24C6, $41CB, $6AB1, $7737, $7B79, $737A, $779A, $779A, $7379, $4231, $0CEA, $052F, $15B6, $1172, $639E, $77BE, $7BDD, $294A, $0843, $0843, $0843, $31AD, $2509
@@DATA000051:
	dw   $0863, $6739, $6B7B, $2D6B, $39AD, $294A, $39AD, $62D8, $6B7B, $39AD, $356B, $354D, $312C, $1CE8, $18A6, $49D1, $45D1, $0843, $18A6, $49D2, $4171, $310D, $28CB, $18A6, $1CC7, $0465, $0CA7, $112D, $08EB, $08EB, $08EB, $0CEA, $0CA7, $294B, $5271, $24C3, $6AB1, $49CB, $24A2, $49C9, $72F4, $72F4, $7777, $7B99, $7FBA, $7F9A, $737A, $779A, $5293, $0CE8, $1172, $15B6, $11B3, $5AF8, $7BFE, $77BD, $2D6B, $1064, $0863, $0843, $318D, $39F0
@@DATA000052:
	dw   $1CC7, $294A, $66F8, $2D6B, $77BD, $739C, $7BDD, $77BE, $56B5, $294B, $2D2B, $312C, $312C, $2529, $0843, $41D0, $45D1, $1CA8, $0843, $1CA8, $49D1, $49D1, $41D0, $18A5, $14A6, $0C85, $0CEA, $08EB, $04ED, $04ED, $08EB, $08EB, $0CE8, $1D08, $66F8, $49CB, $6A71, $562E, $3967, $6AB1, $6AF3, $7737, $7B79, $7FBA, $7B99, $7F9A, $7F9A, $779A, $6718, $0CE8, $156F, $11B3, $04ED, $4EB7, $77BE, $7BDD, $41CF, $14A5, $0421, $0C64, $35AE, $35AE, $294B, $0842
@@DATA000053:
	dw   $0863, $56B5, $1CE7, $77BD, $7BDD, $7BFE, $77BE, $56B5, $4A33, $1CE8, $1063, $1063, $0C63, $1483, $18A6, $45D1, $394E, $1064, $1465, $20E8, $45D1, $41CD, $1483, $2529, $1D2C, $0CEA, $08EB, $04ED, $04ED, $04ED, $052F, $08EB, $14E8, $62D5, $72F0, $72F0, $72F4, $72F4, $7B35, $7B35, $7F79, $7F79, $7B99, $7B99, $7B9A, $7FBA, $7B99, $7379, $31AD, $1D70, $156F, $0465, $4233, $77BD, $7BDE, $66F8, $1CC6, $0842, $0843, $318D, $41F0, $41F0, $318D, $0843
@@DATA000054:
	dw   $1465, $41CF, $1CE7, $739C, $7BFE, $7BFE, $77BE, $4231, $294B, $1CC6, $41CD, $3907, $1CA4, $1483, $1CA8, $1CA8, $45D1, $2509, $41CD, $24C6, $24C5, $2506, $1CC5, $4231, $21B1, $08EB, $08EB, $04ED, $04ED, $04ED, $04ED, $25B3, $0CA7, $5ED7, $6AF3, $72F0, $7B35, $7F79, $7F79, $7F79, $7F79, $7F79, $7F79, $7B99, $7FBA, $7B9A, $7B99, $779A, $5AF8, $1509, $1509, $0465, $4230, $739C, $7BDE, $735A, $1CE7, $0842, $0863, $318D, $39F0, $41F0, $4631, $318D
@@DATA000055:
	dw   $1483, $1064, $1064, $18C7, $18C7, $739C, $7BFE, $7FFF, $77BD, $1CE7, $1CE7, $6735, $6E90, $6E90, $562E, $1CA4, $2D0B, $1CA8, $1064, $1CC5, $41CB, $5E91, $5A2E, $2905, $14A5, $52B6, $31AD, $112D, $052F, $04ED, $04ED, $04ED, $052F, $11B3, $0465, $4210, $7737, $7B35, $7777, $7F79, $7B99, $7FBA, $7B99, $7FBA, $7B99, $7B99, $7B99, $7B99, $7B99, $7FBA, $737C, $41CF, $1084, $1CC6, $5AB4, $7379, $7379, $779A, $35AB, $0842, $0863, $35AE, $39F0, $41F0, $41F0, $39F0
@@DATA000056:
	dw   $0843, $1CE7, $41F0, $4210, $18A5, $2D6B, $5295, $7BDE, $7BDE, $739C, $1483, $2D48, $5E91, $6E6F, $6E6F, $6A71, $2905, $354D, $1465, $0C63, $3569, $5A2E, $6A71, $6AB1, $3967, $14C5, $5AF8, $3213, $1D70, $1172, $052F, $04ED, $04ED, $052F, $11B3, $112D, $35AE, $779A, $7F79, $7F79, $7B99, $7FBA, $7B9A, $7B9A, $7B9A, $7B99, $7B99, $7B99, $7B99, $7B99, $7FBA, $7B9C, $6F39, $6718, $7379, $6F39, $7379, $7379, $7379, $35AB, $0863, $0C64, $318D, $41F0, $41D1, $39F0, $41F0
@@DATA000057:
	dw   $0863, $56B5, $7BDD, $7BDD, $6B5A, $2D6B, $5293, $4631, $77BE, $77BE, $294A, $1CC5, $2D48, $6AB1, $6E90, $6E6F, $6E90, $2903, $28E8, $1CC7, $0821, $41CD, $72F4, $6E90, $6A71, $2905, $14C5, $6739, $4233, $1D70, $15B6, $052F, $052F, $052F, $0DB6, $0DB6, $156F, $216E, $739C, $7B99, $7B99, $7B99, $7B9A, $7B9A, $7B9A, $7B9A, $7B9A, $7B9A, $7FBA, $7B99, $7FBA, $7FBA, $7FBA, $7B9A, $7B9A, $779A, $7B9A, $7FBA, $779A, $7BBD, $294A, $0C63, $0C64, $318D, $49D2, $49D2, $41D1, $41D0
@@DATA000058:
	dw   $1064, $2528, $7BDD, $77BD, $6739, $6B5A, $7BBD, $62D5, $4A31, $7BBD, $4631, $1CA8, $28E8, $3126, $6AB1, $6E90, $6E6F, $5A2E, $28C1, $24A2, $24C3, $1460, $1C41, $6A71, $6A71, $6A71, $1C41, $1CC5, $5F18, $5AF8, $1D72, $15B6, $1172, $052F, $1172, $0A1A, $0DB6, $1172, $1D2C, $739C, $7B9C, $7B99, $7B99, $7B9A, $7B9A, $7B9A, $7B9A, $7FBA, $7B9A, $7B9A, $7B9A, $7B9A, $7B99, $7B99, $7B99, $7B9A, $7B9A, $7B9A, $7BBD, $7BDD, $737A, $18A5, $0842, $0C63, $318D, $4A33, $41D1, $49D2, $41D1
@@DATA000059:
	dw   $1064, $56B5, $7BDD, $294A, $0842, $0863, $2D6B, $4631, $294A, $1CC6, $2509, $310D, $312D, $2506, $6AB1, $6E90, $6E6F, $34E6, $28C1, $3523, $668C, $49C9, $1C41, $49CB, $72F4, $49CB, $1CA3, $1CC4, $5F18, $77BE, $156F, $15B6, $0DB6, $0DB6, $0A1A, $0DB6, $0DB6, $1D72, $1509, $6B7B, $779A, $7FBA, $7FBA, $7B9A, $7B9A, $7B9A, $7B9A, $7FBA, $7FBA, $7B9A, $7B9A, $7B9A, $7B9A, $7B9A, $7B99, $7B9A, $7B9A, $7BBD, $7B9C, $7B9C, $41F0, $1CC6, $1CC7, $1064, $2D6B, $41F0, $41D0, $41D1, $41D1
@@DATA000060:
	dw   $0863, $4A31, $1CC5, $0842, $39AD, $39AD, $1064, $0842, $1483, $2528, $4E33, $310E, $350F, $358D, $49CB, $6E6F, $6E6F, $3907, $24A2, $49C6, $66A9, $728C, $28C1, $1C41, $62D5, $7777, $45CE, $1483, $39CE, $77BE, $21B1, $1172, $0DB6, $0DB6, $0DB6, $0DB6, $15B6, $156F, $1509, $4A74, $7379, $7B9A, $7B9A, $7B9A, $7B9A, $7B9A, $7B9A, $7FBA, $7B99, $7FBA, $7B9A, $7B9A, $7B9A, $7B9A, $7B9A, $7B9A, $7B9A, $7BBD, $7BBD, $6718, $14C5, $14A5, $14C5, $0842, $0C63, $318D, $41F0, $49D2, $41CF
@@DATA000061:
	dw   $0843, $20E8, $2D6B, $14C5, $5ED7, $7BDE, $41F0, $1084, $14A6, $5ED7, $354D, $4171, $350E, $354D, $24C6, $6E90, $6E90, $49CB, $28C1, $3943, $72CB, $72CB, $49C6, $1460, $5271, $779A, $7B79, $4A31, $14A5, $6739, $5F3B, $216E, $25B3, $1617, $0DB6, $15B6, $25B3, $150B, $35AE, $6718, $7B79, $7FBA, $7B9A, $7B9A, $7B9A, $7B9A, $7FBA, $7B9A, $7777, $7B79, $7FBA, $779A, $7B9A, $7B9A, $7B99, $7B9A, $7B9A, $7BBD, $739C, $2529, $18C7, $294A, $14C5, $14A5, $0421, $0842, $2D6B, $2D2B, $2509
@@DATA000062:
	dw   $0C63, $5293, $5AD7, $14A5, $4210, $4631, $14A6, $1084, $1D08, $6739, $394E, $350F, $350F, $310E, $28E8, $34E6, $6A71, $6AB1, $2903, $3523, $49C9, $668C, $49C9, $1CA3, $1CC6, $6F39, $7379, $737A, $41CD, $62D5, $739C, $39F0, $0CEA, $08EB, $112D, $25B3, $5F3B, $5AF8, $6739, $779A, $7FBA, $7B99, $7B9A, $7B9A, $7B9A, $7B99, $7B79, $62D5, $4A2F, $5271, $6735, $7379, $7FBA, $7B9A, $7FBA, $7FBA, $779A, $7B9C, $39AD, $18C7, $39AD, $5AD7, $14C5, $4230, $14C5, $0C63, $0842, $18C7, $18C7
@@DATA000063:
	dw   $0843, $1CC7, $7BDE, $6B5A, $1D08, $1064, $1084, $14C5, $18A6, $5674, $5674, $354D, $350F, $350F, $350F, $350E, $1465, $28E8, $5E91, $6AB1, $24A2, $1C41, $2905, $1CA4, $1CC5, $1465, $4A31, $7B99, $7379, $7B79, $7B79, $7F79, $6F39, $6F39, $66F8, $6718, $6718, $735A, $737A, $779A, $7B99, $7B99, $7B9A, $7B99, $7B9A, $7B9A, $7B9A, $62D5, $2506, $4A2F, $5271, $356A, $7379, $7FBA, $7FBA, $7FBA, $7FBA, $779A, $45CE, $1CC6, $2528, $737C, $7BDD, $31AD, $6B5A, $4A74, $1084, $0C64, $31AD, $2D2B
@@DATA000064:
	dw   $0C63, $5293, $7BBD, $7FFF, $41F0, $0863, $1084, $1084, $2509, $737C, $396E, $310E, $350F, $350F, $350F, $350E, $310D, $1465, $24C5, $5A71, $5A71, $24C5, $1CA4, $2509, $49D2, $1CA8, $1CC5, $5271, $779A, $7B79, $7737, $7B35, $7B35, $7B35, $7737, $7737, $7737, $7777, $7B79, $7B9A, $7B99, $7B99, $7B99, $7B9A, $7FBA, $7B9A, $7F9A, $4A2F, $6735, $7F9A, $5AB4, $5271, $7FBA, $7FBA, $7B9A, $779A, $7BBD, $5AB4, $1CA4, $1CC7, $6718, $7BDE, $7BDE, $4A74, $4631, $739C, $4231, $0C64, $1CE8
@@DATA000065:
	dw   $0863, $6718, $7BDE, $7BBD, $5ED7, $14C5, $0C85, $14A6, $5295, $5ED7, $394E, $310E, $350F, $350F, $350F, $350F, $310E, $350F, $20E8, $1465, $45CE, $24C5, $2D29, $396E, $4993, $4993, $18A6, $18A5, $4A31, $7737, $7737, $7B35, $7B35, $7B35, $7B35, $7B35, $7B35, $7777, $7B99, $7B99, $7B99, $7B99, $7B99, $7B99, $7FBA, $7FBA, $7F9A, $7737, $7737, $7B79, $7379, $7B79, $7FBA, $7B9A, $7B9C, $779A, $5293, $18A5, $1465, $2D2B, $4E33, $6739, $7FDF, $7BDE, $318D, $4631, $4A74, $2528
@@DATA000066:
	dw   $0843, $6718, $7BDE, $7FDF, $739C, $14C5, $0C85, $2529, $737C, $41D0, $310D, $350F, $350F, $310E, $310E, $310E, $350F, $310E, $312C, $28E8, $1063, $1042, $18A5, $45D1, $4993, $4DD4, $41D0, $18A6, $18A5, $356A, $66D4, $72F4, $7B35, $7B35, $7777, $7B35, $7777, $7777, $7B99, $7B99, $7B99, $7B99, $7B9A, $7FBA, $7FBA, $7F9A, $7F9A, $7F9A, $7F9A, $7F9A, $7B9C, $7B9A, $7B9A, $7B9A, $737A, $5674, $18A6, $1064, $24C9, $312C, $41CF, $62D8, $7BDE, $7FFF, $7BBD, $1CE7, $4230, $1CE7
@@DATA000067:
	dw   $0863, $56B5, $7FDF, $7FDF, $5AD6, $14C5, $18C7, $56D7, $5634, $310D, $350F, $350F, $350F, $310E, $310E, $310E, $350F, $310E, $312D, $2509, $0C64, $14C5, $1CC6, $41CF, $4993, $4993, $5A56, $4A33, $18A6, $1CC7, $24C5, $5A71, $6735, $7737, $7B79, $7B79, $7B79, $7B99, $7B9A, $7B9A, $7FBA, $7B99, $7B99, $7FBA, $7FBA, $7B9A, $7F9A, $7F9A, $7F9A, $779A, $779A, $779A, $7B9A, $7379, $2D48, $1483, $1063, $1CA8, $2D0C, $312D, $310D, $41D1, $735C, $7FDF, $7FDF, $5F18, $2949, $0842
@@DATA000068:
	dw   $1CE7, $2529, $7BDE, $77BD, $2D6B, $14C5, $4631, $737C, $2D0C, $310E, $350F, $350F, $350F, $310E, $350F, $310E, $350F, $350E, $312C, $1064, $10C7, $18C7, $14A5, $356B, $49B2, $4DD4, $4E33, $735C, $294C, $2D6B, $41CF, $1CE7, $2D48, $5271, $6F39, $7379, $7B9A, $7B9A, $7FBA, $7FBA, $7B99, $7B99, $7B9A, $7B9A, $7FBA, $7FBA, $7FBA, $7FBA, $779A, $779A, $7BFE, $77BD, $6718, $2949, $1CC4, $0821, $2509, $312D, $350E, $310D, $310E, $394F, $5A56, $7BBD, $7FFF, $7BBD, $62D5, $0842, $1064
@@DATA000069:
	dw   $1064, $7BFF, $4631, $14C5, $294A, $737C, $5ED7, $2D0C, $350E, $350F, $350E, $350F, $310E, $350F, $310E, $350F, $310E, $20E8, $0843, $14E8, $0CE8, $0C85, $1CE8, $416F, $4993, $49D2, $66F8, $7BBD, $2529, $4230, $5AD6, $2509, $1CC7, $294A, $5AD6, $735A, $735A, $779A, $7F9A, $7F79, $7F9A, $7FBA, $7B9A, $7B9A, $7B9A, $7B9A, $779A, $779A, $737A, $56B5, $294B, $14C5, $1CC4, $2506, $24C5, $41CD, $2D0C, $350E, $350F, $310E, $310E, $416F, $56B5, $7BDE, $7BDE, $77BD, $0863
@@DATA000070:
	dw   $0843, $35AE, $18C7, $18A5, $5AD7, $737C, $45D1, $394E, $350E, $350E, $4171, $350E, $350F, $350F, $350F, $310E, $2D0C, $18A6, $2529, $0CE8, $0CE8, $14E8, $0C64, $312D, $49B2, $49B2, $4E33, $6739, $739C, $294A, $4631, $5AD7, $2D2B, $18A5, $1CC5, $20E8, $4A31, $62D5, $7B79, $7B79, $7B79, $7379, $737A, $7379, $5AD6, $5AD6, $5AB4, $318D, $10C7, $0421, $0C85, $14C5, $2D48, $4E2C, $3967, $1CA4, $4590, $4DD4, $350F, $350F, $350F, $312D, $396E, $6739, $7BBD, $77BD, $0863
@@DATA000071:
	dw   $1084, $1084, $1084, $358D, $737C, $5A56, $49B3, $350E, $350E, $49B2, $4171, $310E, $350F, $350F, $310E, $312D, $18C7, $18C7, $52B6, $1D2C, $0CE8, $0CE8, $0465, $2D0B, $416F, $4D94, $49B3, $5674, $735A, $7BBD, $4E74, $4631, $5674, $39AD, $1CE7, $18A5, $1483, $1CA4, $1CC5, $1CA4, $356B, $294A, $1483, $0863, $1064, $0C64, $0C64, $0465, $0465, $0CE8, $0CE8, $0421, $24C3, $72F0, $49C6, $1CA3, $2D2B, $396E, $49D2, $4DD4, $4171, $350F, $312D, $49D2, $735C, $5AD7, $0863
@@DATA000072:
	dw   $0843, $0863, $14C5, $739C, $5A56, $49B3, $350E, $350E, $4590, $4171, $350E, $350F, $350F, $350F, $312D, $2509, $1D08, $5AD7, $6B5A, $4A74, $1509, $0CE8, $0CA7, $0C64, $312D, $4993, $4993, $49D2, $5ED7, $737C, $7FFF, $7FDF, $4A33, $39AD, $4A31, $1CE7, $1084, $1CE7, $35AB, $2D48, $24C5, $1483, $0821, $0843, $0C85, $0CA7, $0CE8, $08EB, $08EB, $08EB, $0CA7, $0421, $3967, $72F0, $3943, $3DAA, $1CC7, $20E8, $312C, $4590, $4993, $49B2, $4171, $49D1, $62D8, $39F0, $0C64
@@DATA000073:
	dw   $0C63, $1084, $5674, $56B5, $396E, $310D, $350F, $4171, $4590, $350E, $310D, $350F, $350F, $310D, $1867, $0843, $358D, $6B5A, $739C, $5AF8, $35AE, $1D08, $1D08, $0421, $1CC7, $41D0, $4993, $49B3, $4E33, $62D8, $7BDE, $7FFF, $7FDF, $6718, $4A2F, $39AD, $20E8, $1063, $24C5, $49C9, $6AB1, $41C9, $1460, $1084, $14E8, $0CE8, $112D, $04ED, $04ED, $156F, $0CA7, $1CC5, $41CB, $564C, $3523, $3569, $18A5, $294B, $1064, $2D0B, $49B2, $4D94, $4D94, $49D2, $56B5, $1CC7
@@DATA000074:
	dw   $14A5, $35AE, $62D8, $2D6B, $354D, $350E, $4993, $49B3, $350E, $310E, $310E, $350F, $350F, $0843, $1D08, $1CE8, $735A, $6B5A, $6739, $39F0, $31AD, $35AE, $1D29, $1084, $14A5, $2D2B, $396E, $4DD4, $49B3, $4E33, $62D8, $7BFF, $7FFF, $7FFF, $7FDF, $7BFE, $7B9C, $4A31, $2905, $24A2, $3943, $564C, $5A6F, $3126, $0863, $1509, $08EB, $04ED, $156F, $216E, $0C64, $4A2F, $24A2, $1C41, $49CB, $24C5, $1CA4, $0863, $18C7, $18A6, $416F, $4D94, $4993, $49D2, $41D0
@@DATA000075:
	dw   $14A5, $2D6B, $62D8, $312D, $2D2B, $2509, $49D1, $49B2, $4171, $310E, $350E, $350F, $350F, $310E, $2509, $2D6B, $4210, $739C, $6B7B, $4A74, $294B, $1509, $1D2C, $31AD, $1D08, $0C64, $1CC7, $2D0B, $4171, $49B3, $49B3, $49D2, $56B5, $77BE, $7BDE, $739C, $7BBD, $7FDF, $7BBD, $7BDD, $737A, $4A31, $1C41, $2905, $628D, $41C9, $0C64, $08EB, $156F, $156F, $0CA7, $0821, $49C9, $28C1, $3126, $2D48, $1063, $4631, $5AF8, $1CE8, $2509, $312C, $4D94, $4D94, $4590, $1CE8
@@DATA000076:
	dw   $14A5, $2D6B, $6739, $312D, $2D0B, $18A5, $1CA8, $49D1, $394F, $310E, $350F, $350F, $350F, $350F, $312D, $1CA4, $41CB, $35AB, $6B5A, $4A74, $294C, $0CA7, $150B, $216E, $1509, $1D2C, $0C64, $0863, $294B, $396E, $49B3, $4DD4, $4993, $49D1, $49D1, $4631, $49D1, $5634, $62D8, $737C, $7BDE, $7FFF, $7FFF, $5F18, $2905, $5E6B, $4E2C, $1084, $150B, $08EB, $0CA7, $10C7, $3569, $3943, $564C, $45CE, $0821, $4A33, $77BD, $77BD, $31AD, $358D, $394F, $49B2, $4993, $312D
@@DATA000077:
	dw   $0C85, $14A6, $62D8, $45D1, $312C, $18A6, $20E8, $354D, $394F, $350E, $350F, $310E, $350F, $350F, $350F, $312D, $2903, $4E2C, $2506, $56B5, $31AD, $150B, $1D70, $1D70, $1D70, $216E, $150B, $1509, $0C64, $0C64, $312C, $49B2, $4993, $4D94, $4993, $49B3, $49B3, $4993, $4D94, $4DD4, $4E33, $62D8, $77BE, $7FFF, $7FFF, $62D5, $3967, $562E, $14A5, $0C85, $1509, $4E74, $6B5A, $6718, $24C6, $3126, $1042, $1064, $31AD, $77BE, $7FDF, $358D, $24C9, $312D, $4DD4, $416F, $18A6, $0C63
@@DATA000078:
	dw   $1084, $5F18, $4E33, $312C, $2D0B, $1064, $396E, $416F, $350E, $310E, $350F, $310E, $350F, $350F, $350F, $2D0C, $3126, $5A6F, $3967, $1CC7, $1509, $216E, $1D70, $25B3, $1D72, $1D70, $150B, $0CA7, $10C7, $18C7, $1CA8, $1CA8, $24C9, $310E, $4590, $49B2, $49B2, $4D94, $4D94, $4D94, $4993, $49D1, $5674, $77BE, $7FFF, $7FDF, $562E, $5A71, $1CC7, $6B7B, $77BD, $7BFE, $7BDD, $7BBD, $5674, $1465, $5271, $1CC5, $14E8, $4A74, $7BBD, $5674, $28CB, $41D1, $1CE8, $1CE8, $4631, $1084
@@DATA000079:
	dw   $0842, $41CF, $77BD, $2D2B, $358D, $1465, $312C, $4590, $350E, $350E, $350F, $310E, $310E, $350F, $350F, $350E, $28E8, $1CA3, $4E2C, $5E91, $1CA3, $1D08, $1D70, $1D72, $1D72, $1D72, $156F, $0CEA, $1509, $1D2C, $1D29, $14E8, $14E8, $14E8, $14E8, $0C85, $2509, $312C, $4590, $49B2, $4D94, $4D94, $4993, $49B2, $5634, $7B9C, $7BBD, $4A31, $35AB, $1CC7, $77BD, $7FFF, $7FFF, $7FFF, $7FFF, $7BDD, $5ED7, $356A, $41CD, $0C85, $1D29, $6B7B, $4631, $312D, $28CB, $294C, $39F0, $35AE, $0863
@@DATA000080:
	dw   $0842, $1CC7, $7B9C, $6718, $358D, $1465, $18A6, $45D1, $416F, $350E, $350F, $350F, $310E, $310E, $350F, $2D0C, $24C6, $24C6, $356B, $1CA3, $562E, $4E2C, $1042, $1509, $216E, $1D70, $1D70, $0CEA, $0CE8, $31AD, $4EB7, $4A74, $1D2C, $0CE8, $1509, $0CE8, $14E8, $1084, $1CC5, $2D48, $562E, $38E8, $2D0C, $4DD4, $4D94, $49B2, $5E76, $735A, $294B, $18C7, $14C5, $739C, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7BBD, $2927, $4A2F, $1D08, $1CA8, $41CF, $4A33, $24C9, $18A6, $4A33, $318D, $14A6, $0863
@@DATA000081:
	dw   $0842, $5271, $7BBD, $4A33, $1CE8, $1064, $45D1, $416F, $310D, $350F, $350F, $310E, $310E, $310E, $28E8, $24C5, $3569, $41CD, $0C63, $0821, $24C3, $5A6F, $564C, $1460, $1D29, $216E, $150B, $0CE8, $1509, $35F1, $6B9C, $5F3B, $35F1, $1509, $0CEA, $0CE8, $10C7, $14C5, $1460, $564C, $626B, $49C6, $3523, $28E8, $49B2, $4DD4, $49D2, $56B5, $1CC6, $1084, $39F0, $7BFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7BDE, $779A, $2D48, $4A31, $1064, $18C7, $4E74, $2D6B, $35AE, $318D, $294B, $0C64
@@DATA000082:
	dw   $0843, $2528, $735A, $7BBD, $2509, $1064, $20E8, $49D1, $416F, $350E, $350F, $350F, $310E, $310E, $2D0B, $24A2, $564C, $66D4, $2506, $14C5, $1084, $1063, $3126, $5E6B, $564C, $14C5, $0CA7, $10C7, $10C7, $1509, $294B, $4233, $35F1, $1D2C, $14E8, $10C7, $18C7, $1084, $1CA3, $28C1, $626B, $6667, $6667, $49C9, $1020, $350E, $49B3, $49D2, $4A33, $1483, $2D6B, $77BE, $7FDF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7BDD, $5271, $41CD, $358D, $14A6, $294B, $4A74, $35AE, $4631, $18C7, $0C64
@@DATA000083:
	dw   $0C63, $41CF, $77BD, $5F18, $0843, $1064, $45D1, $416F, $312D, $350E, $350F, $350F, $310E, $310E, $2D0B, $24A2, $5A6F, $562E, $1CC5, $0C64, $14E8, $294B, $14A5, $41CB, $66D4, $5F18, $31AD, $10C7, $0C85, $14E8, $0CA7, $1D29, $1D29, $18C7, $18C7, $1CA4, $1460, $24A2, $49C6, $6667, $6667, $6667, $6667, $3943, $562E, $1CA8, $41D1, $41D1, $2D2B, $1483, $6B5A, $7BFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FDF, $7B9C, $356B, $4A31, $1CC6, $14C5, $35AB, $0C63, $318D, $358D, $14A6
@@DATA000084:
	dw   $0843, $0C63, $739C, $6718, $1D08, $1064, $24C9, $49D1, $394F, $310D, $350F, $350F, $350F, $310E, $310E, $312C, $1020, $49C9, $562E, $24C5, $0C85, $1509, $216E, $1D29, $1042, $4A2F, $737C, $739C, $56B5, $358D, $294A, $1CC4, $24C5, $2905, $2905, $3967, $49C9, $628D, $668C, $626B, $6667, $66A9, $6667, $3943, $5A6F, $356A, $1063, $2D0B, $4A33, $1064, $35AB, $7BBD, $77BE, $7FFF, $7FFF, $7BFF, $7FFF, $7FFF, $7BFE, $7BFE, $7BDE, $5674, $4210, $356A, $45CE, $1CC5, $1483, $0421, $1CC7, $2529, $1064
@@DATA000085:
	dw   $0421, $2529, $739C, $4631, $1064, $0821, $312C, $416F, $310E, $350F, $350F, $350F, $350F, $310E, $310E, $312D, $1460, $3966, $564C, $2903, $18C7, $0CA7, $216E, $216E, $1D29, $0C64, $1D08, $6F39, $7F9A, $6AB1, $626B, $626B, $6667, $6667, $6667, $7B2B, $7B2B, $7F4D, $66A9, $668C, $72F0, $628D, $49CB, $5271, $1CA4, $28E8, $41CD, $2D29, $2D2B, $1CC7, $6B5A, $7BBD, $7FDF, $7BFF, $77BD, $739C, $739C, $6B5A, $6B7B, $77BD, $77BE, $56D7, $52B6, $41F0, $4A2F, $3569, $0821, $20E8, $358D, $2529, $1084, $1084
@@DATA000086:
	dw   $0843, $4631, $5AD7, $18A5, $0821, $0821, $354D, $394F, $350E, $350F, $350F, $350F, $350F, $310E, $310E, $2D0B, $1020, $24C3, $5E6B, $3966, $1CA3, $10C7, $0CEA, $1D70, $1D2C, $10C7, $14A6, $1483, $3126, $562E, $5E6B, $6667, $6667, $6667, $7B2B, $7F4B, $7F4B, $7F4D, $72F0, $564C, $24A2, $1460, $2528, $2D2B, $394E, $45D1, $45CE, $39AD, $18A5, $41F0, $6B7B, $739C, $6739, $6718, $56D7, $52B6, $5AD7, $52B6, $56D7, $77BE, $7BFF, $5295, $5295, $56B5, $41CB, $41CD, $1CC5, $18A6, $6718, $737A, $35AB, $0863
@@DATA000087:
	dw   $0843, $5674, $356B, $1483, $0421, $0843, $312D, $350F, $350F, $350F, $350F, $350F, $350F, $350F, $310E, $1CA8, $2927, $2903, $5E6B, $668C, $24C3, $18A6, $14E8, $0CA7, $1D29, $10C7, $18C7, $18C7, $1CC6, $1CC5, $2506, $1CA3, $1460, $1C41, $3943, $49C6, $49C6, $41C9, $3DAA, $1483, $1042, $0842, $1CC6, $1CE8, $49B2, $49B2, $45D1, $18A5, $1D08, $5AF8, $56B5, $5F18, $56D7, $52B6, $5295, $5295, $5295, $5295, $4E94, $6B7B, $6B7B, $5295, $5295, $52B6, $294A, $2949, $4A31, $20E8, $66F8, $737A, $5AD6, $0C64
@@DATA000088:
	dw   $1084, $4A31, $1483, $1CC5, $0421, $0843, $354D, $350F, $350F, $350E, $350F, $350F, $350F, $350F, $310D, $1064, $35AB, $1CA3, $49C9, $5E6B, $5A6F, $24C5, $1CA8, $14E8, $0C85, $0465, $0C85, $0C85, $0C64, $1084, $0843, $0842, $14A5, $1CC4, $3126, $3967, $3DAA, $45CE, $2D6B, $0C64, $14E8, $1CE8, $18C7, $18A6, $4590, $49B2, $49D1, $358D, $18A6, $2509, $1D08, $35AE, $4E74, $52B6, $5295, $5295, $5295, $5295, $5295, $52B6, $5295, $5295, $5295, $5295, $31AD, $1084, $5AB4, $6718, $356B, $737A, $737A, $0C63
@@DATA000089:
	dw   $0863, $18A5, $1460, $2D48, $0863, $0843, $312D, $350F, $350F, $350F, $350F, $350F, $350F, $310E, $2509, $1084, $1D08, $2D6B, $24C5, $5E91, $66D4, $66D4, $294B, $0C85, $10C7, $10C7, $14A6, $0C64, $0C85, $18C7, $1D08, $2949, $6735, $5E6B, $5E6B, $4E2C, $3126, $1CC5, $0842, $14E8, $216E, $150B, $14E8, $18C7, $28E8, $49D1, $45D1, $41D0, $5634, $5E76, $6718, $41CF, $2D6B, $4E74, $5295, $5295, $5295, $5295, $5295, $5295, $5295, $5295, $52B6, $31AD, $18C7, $1CE7, $3569, $4E2C, $2506, $737A, $739C, $0863
@@DATA000090:
	dw   $0421, $1063
@@DATA000091:
	dw   $1483, $0421, $310D, $350F, $350F, $350F, $350F, $350F, $350F, $310E, $18A6, $0C63, $4231, $5295, $41F0, $1CA4, $5271, $7B9A, $6B5A, $4A74, $294B, $2529, $294B, $41F0, $4A74, $4E74, $4231, $2D6B, $3126, $3523, $3523, $28C1, $24A2, $1CC4, $14C5, $1D29, $216E, $150B, $0CE8, $18C7, $2927, $356A, $18A6, $2D0B, $41D1, $49D2, $5634, $5ED7, $2529, $5295, $5295, $5295, $5295, $5295, $5295, $5295, $5295, $5295, $4EB7, $35AE, $18A6, $5271, $66D4, $4A2F, $35AB, $6B5A, $6739, $0843
@@DATA000092:
	dw   $1483, $1020
@@DATA000093:
	dw   $0821, $18A6, $350E, $350F, $350F, $350F, $350F, $350F, $312D, $0C63, $2529, $5295, $4EB7, $4E74, $41F0, $1483, $5271, $737A, $6B5A, $5AD7, $5295, $41F0, $358D, $35AE, $31AD, $318D, $294A, $356B, $41CD, $45CE, $2905, $1C41, $5E91, $3569, $14A5, $216E, $216E, $10C7, $1CC4, $5A6F, $41C9, $4A2F, $39AD, $312C, $41D1, $49D1, $4E33, $312D, $4E74, $5295, $5295, $5295, $5295, $5295, $5295, $5295, $5295, $52B6, $39F0, $18C7, $4A33, $735A, $39AD, $18C7, $6739, $18A5, $1084
@@DATA000094:
	dw   $1020, $0821
@@DATA000095:
	dw   $1CA4, $1042, $2D0B, $350F, $350F, $350F, $350F, $310E, $18A6, $0843, $18C7, $4E74, $4EB7, $5295, $4E74, $4631, $1CE7, $294A, $358D, $2D6B, $358D, $4A33, $56B5, $4A74, $4A74, $5295, $4A74, $318D, $358D, $4631, $1CA4, $3126, $5A6F, $5A6F, $24C3, $1064, $10C7, $1CC4, $3966, $564C, $2903, $5271, $4A74, $396E, $41D0, $312D, $24C9, $4233, $5295, $5295, $5295, $5295, $5295, $5295, $5295, $5295, $4E94, $4E74, $18C7, $14A6, $18C7, $6718, $6739, $2D2B, $294A
@@DATA000096:
	dw   $1C41
@@DATA000097:
	dw   $1020, $1042, $2D0C, $350F, $350F, $350F, $2D0B, $0821, $2529, $294B, $294B, $4EB7, $4EB7, $4E74, $5295, $5295, $39F0, $35AE, $41F0, $39CE, $4A74, $4A74, $5674, $4A33, $358D, $318D, $35AE, $5295, $39F0, $14A5, $1020, $3967, $668C, $5E6B, $24C3, $1CA3, $24A2, $564C, $41C9, $3DAA, $5293, $5295, $39CE, $2509, $1CE8, $4A33, $4EB7, $5295, $5295, $5295, $5295, $4EB7, $5295, $5295, $4A74, $39CE, $18C7, $0C64, $14A6, $1CE7, $5293, $7BDD, $737A
@@DATA000098:
	dw   $24A2
@@DATA000099:
	dw   $1020, $1063, $350E, $350F, $310E, $18A6, $0821, $4631, $39F0, $31AD, $56D7, $5AF8, $5F18, $52B6, $5295, $56D7, $56D7, $56B5, $5295, $56B5, $39F0, $294C, $2D6B, $39CE, $56B5, $5F18, $5F18, $1CE7, $1483, $1064, $1CA4, $5E6B, $72CB, $5E6B, $28C1, $3943, $5E6B, $3126, $66D4, $5293, $5295, $4631, $14A5, $35AE, $4E74, $4E74, $5295, $4E74, $4E94, $4E94, $4A33, $318D, $2529, $14C5, $1084, $294B, $18A6, $14A5, $1CE7, $5AD6, $77BD, $294A
@@DATA000100:
	dw   $28E8, $1465, $350E, $350E, $18A5, $1483, $39CE, $0C85, $294B, $5F18, $77BD, $6B9C, $5F18, $5AF8, $5AF8, $5295, $35AE, $318D, $318D, $39F0, $4631, $5AD7, $5F18, $6B5A, $739C, $318D, $4A2F, $1CC5, $14E8, $18C7, $1CA3, $628D, $7F4D, $7B2B, $6667, $49C6, $24A2, $356A, $35AB, $4A33, $5293, $24C6, $35AB, $4230, $35AB, $2D6B, $294A, $1CE7, $1CC6, $14C5, $3126, $2D48, $1CC6, $18C7, $6739, $5F18, $1483, $1CC5, $39AD, $2529, $294B
@@DATA000101:
	dw   $24C6, $1C41, $2D0C, $18A5, $2528, $41CF, $14A6, $1CE8, $294B, $2D6B, $318D, $4631, $39F0, $41F0, $41F0, $39F0, $4A33, $56B5, $5AF8, $5F18, $6B7B, $77BD, $77BD, $5295, $2D6B, $5A71, $24C5, $10C7, $0CE8, $0C85, $1CA3, $72CB, $7F4D, $72CB, $28C1, $3126, $2D29, $1CC6, $18A5, $356A, $2506, $1CA4, $24C6, $24C5, $1CC5, $2506, $2927, $0821, $2506, $6AF3, $6AF3, $2927, $14A5, $39CE, $77BD, $2528, $18A5, $18A6, $4210, $5AF8
@@DATA000102:
	dw   $38E8, $1020, $0821, $5ED7, $41CF, $39F0, $5AD7, $56B5, $5293, $4A74, $4E94, $56B5, $56B5, $5AD7, $5F18, $5F18, $6B7B, $77BE, $7FFF, $7FFF, $7FFF, $7BDD, $1CE8, $35AB, $628D, $28C1, $10C7, $150B, $0CEA, $0C85, $2903, $6AF3, $3DAA, $1020, $1CC5, $1CE7, $2528, $356A, $356A, $2D29, $28E8, $2D29, $2D29, $356B, $2D48, $1CC5, $35AB, $3569, $3967, $5A6F, $6AF3, $2905, $10C7, $318D, $1CC6, $1042, $1CC6
@@DATA000103:
	dw   $1042, $0821, $4A33, $1CE8, $5295, $56B5, $6718, $6718, $5F18, $6718, $6739, $6739, $737A, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $5AD6, $1CC5, $4A2F, $5E6B, $28C1, $1509, $156F, $1D70, $1509, $14A6, $1CC5, $1064, $18A6, $18C7, $18C7, $1CA4, $1460, $2506, $2927, $2D29, $356B, $356B, $2D29, $24C6, $356B, $7B9C, $7BBD, $66D4, $2903, $6AF3, $41C9, $14C5, $1CE8, $2506, $1CC4
@@DATA000104:
	dw   $0842, $1042, $1CC7, $294B, $735A, $739C, $7FFF, $7FFF, $77BE, $6B7B, $6718, $739C, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7BDE, $356B, $35AB, $4E2C, $5E6B, $3523, $294B, $1D70, $1D70, $150B, $1509, $0465, $0C64, $1CE8, $10C7, $18C7, $3126, $3126, $562E, $3126, $1CC5, $356A, $2D29, $2506, $2D48, $7B9C, $7BBD, $7FDF, $739C, $1CC5, $5AB4, $66D4, $24C5, $2506, $41CB, $1460
@@DATA000105:
	dw   $0842, $356A, $737C, $35AB, $7BBD, $7FFF, $7FFF, $7FFF, $6B7B, $5F18, $52B6, $6739, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7BDE, $56B5, $4A31, $7379, $4E2C, $5E6B, $3967, $1D29, $216E, $1D70, $150B, $0CE8, $150B, $14E8, $10C7, $10C7, $14C5, $24A2, $5A6F, $5A6F, $4E2C, $4A2F, $739C, $4A31, $62D5, $7BBD, $7BBD, $7FDF, $7FFF, $77BD, $14C5, $1CC5, $6735, $3523, $3943, $41C9
@@DATA000106:
	dw   $0842, $5A71, $735A, $62D5, $7FFF, $7FFF, $7FFF, $77BE, $5F18, $5295, $5295, $5F18, $7FDF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7BDE, $18C7, $4210, $7BDD, $41CB, $6AB1, $7737, $1CE8, $1D2C, $1D2C, $150B, $0CEA, $0CA7, $10C7, $1D08, $10C7, $1CC6, $6AB1, $5E6B, $4E2C, $3569, $7FFF, $7BBD, $7BDD, $7BFE, $7BFF, $7BFF, $77BE, $6739, $7BDD, $2D6B, $14A5, $5E91, $72CB, $66A9, $2905
@@DATA000107:
	dw   $0842, $1CA4, $39AD, $2949, $77BD, $7BFE, $6B7B, $5AF8, $5295, $5295, $5295, $5AF8, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7BFF, $4231, $1D29, $318D, $66F8, $356A, $562E, $7FBA, $4210, $0CE8, $14E8, $0CE8, $0CE8, $10C7, $14C5, $1483, $39CE, $739C, $7777, $49C9, $41C9, $7FBA, $7BDD, $7BFE, $7BFE, $7BFE, $7BFF, $7FDF, $739C, $39F0, $7BDD, $4230, $1CC6, $24C3, $668C, $626B
@@DATA000108:
	dw   $1063, $1084, $14C5, $39CE, $6B7B, $5F18, $5295, $5295, $5295, $5295, $5AF8, $7FFF, $7FFF, $7FFF, $7FFF, $7FDF, $7BDD, $294B, $2D6B, $1CC6, $1CC7, $294A, $3569, $7BBD, $739C, $10C7, $14E8, $10C7, $14E8, $0C63, $3967, $6735, $737A, $6B7B, $41CD, $4A2F, $7BBD, $7BFE, $7FFF, $7BFE, $7FDF, $7FFF, $7FFF, $7FDF, $739C, $39AD, $7BBD, $4A31, $1CC5, $1CC4, $5E91
@@DATA000109:
	dw   $14A5, $1064, $1465, $1084, $294A, $6B5A, $2529, $4A33, $56B5, $5295, $5295, $5295, $5295, $6739, $7FFF, $7FFF, $7FFF, $7FDF, $7FFF, $737C, $18C7, $1CC6, $1CC6, $14C5, $0C63, $0C63, $5293, $737A, $5295, $1D08, $1D08, $1CA4, $3DAA, $668C, $628D, $62D5, $318D, $77BD, $7BDE, $7FFF, $7BDE, $7FFF, $7FDF, $7FDF, $7FFF, $7BDE, $77BE, $6739, $35AE, $7BDE, $62D8, $14A5, $14A5, $2949, $14C5
@@DATA000110:
	dw   $1CE7, $18C7, $1D08, $41F0, $5674, $1CE7, $18C7, $39CE, $1D08, $18C7, $5AD7, $56B5, $5295, $5295, $5295, $5F18, $7FFF, $7FFF, $7FFF, $7BDD, $7BDE, $4A33, $1064, $1064, $1CC7, $14C5, $1CC6, $1CE7, $14A5, $5AB4, $5AB4, $3DAA, $3126, $3943, $668C, $66A9, $626B, $41CB, $739C, $7BBD, $7BFE, $7BDD, $7FFF, $7BFE, $7FFF, $7FFF, $7BFE, $7FFF, $77BE, $5AF8, $4231, $77BE, $6739, $1CC6, $1084, $14A5, $1084
@@DATA000111:
	dw   $14A6, $1CC6, $2528, $4631, $52B6, $5295, $4E74, $4631, $294A, $14C5, $39CE, $5ED7, $294A, $5ED7, $56B5, $5295, $5295, $6718, $7BDE, $7FFF, $7FFF, $7FFF, $7FDF, $41CF, $0C64, $0421, $14C5, $1CE7, $14C5, $14C5, $1CE7, $1CC6, $5A71, $5A6F, $49C9, $6667, $6667, $72CB, $49C6, $5271, $7BBD, $7FFF, $7BFE, $7FFF, $7FFF, $7BBD, $7FFF, $7BFE, $7BFF, $7BFE, $77BE, $52B6, $4631, $4A74, $35AE, $18A5, $1CC6, $5293, $0C63
@@DATA000112:
	dw   $14A5, $1CC6, $6F39, $6739, $4E74, $52B6, $5295, $5295, $5295, $56B5, $35AE, $358D, $735A, $358D, $18A5, $294A, $41F0, $56B5, $77BD, $7BFE, $7BDE, $7BDE, $7BDE, $39CE, $2509, $1064, $0000, $1483, $1CC6, $18C7, $18C7, $14C5, $14A6, $1483, $41CB, $628D, $7B2B, $7B2B, $628D, $24C3, $5AD6, $6B9C, $77BD, $739C, $7FFF, $77BD, $7BFE, $7BDD, $7BFE, $7BBD, $7BFE, $7BBD, $5674, $1CE7, $1CC5, $1CE7, $1084, $2D6B, $5AD6
@@DATA000113:
	dw   $1CE7, $2927, $7BDE, $7BDE, $77BD, $5AD7, $52B6, $5295, $5295, $5295, $5295, $358D, $1D08, $41CF, $1CC6, $1CC6, $2528, $1CC6, $14A5, $39CE, $4210, $4631, $35AE, $294B, $1CC7, $4E33, $1064, $0000, $14C5, $14A5, $14C5, $1D08, $294B, $1D29, $14A6, $1460, $3966, $66A9, $72CB, $4E2C, $18C7, $1D29, $150B, $35F1, $5F3B, $77BE, $77BE, $7BFF, $77BD, $77BE, $77BD, $77BE, $7BBD, $5674, $1CC5, $1CA4, $0C63, $1483, $4A31, $737A, $5293
@@DATA000114:
	dw   $1CC6, $7BBD, $7FFF, $7FFF, $7FDF, $6B5A, $5295, $5295, $5295, $5295, $5295, $4231, $18C7, $18C7, $14A5, $294A, $6739, $358D, $1084, $294B, $2528, $2529, $294A, $2529, $4A31, $294A, $0C63, $0000, $1084, $14C5, $14C5, $2529, $2D6B, $294A, $1CC7, $1CC5, $1460, $1CA3, $2927, $14C5, $216E, $156F, $1172, $1172, $08EB, $3213, $4EB7, $5F3B, $5F18, $739C, $6B9C, $77BE, $56B5, $1CC7, $2529, $0C63, $1084, $294A, $6B5A, $7BBD, $7BBD, $1CE8
@@DATA000115:
	dw   $1CC6, $7BBD, $7FFF, $7FFF, $7FFF, $7BDD, $6718, $4E74, $56B5, $5295, $4A74, $41F0, $0C64, $14A6, $1CC7, $14C5, $318D, $14A5, $2528, $294A, $4631, $7BBD, $5AD7, $5ED7, $39CE, $1084
@@DATA000116:
	dw   $0421, $14C5, $14C5, $14C5, $294A, $2D6B, $294A, $1CE7, $1CC5, $1CC6, $1084, $0C64, $0CA7, $0CA7, $04ED, $1172, $156F, $1172, $156F, $08EB, $112D, $0CE8, $0CEA, $0CE8, $0CE8, $10C7, $0C85, $0C64, $0C64, $2529, $6718, $739C, $7BBD, $7BDE, $4A31
@@DATA000117:
	dw   $1CC6, $39AD, $7FDF, $7FFF, $7FFF, $7FFF, $739C, $5F18, $56B5, $5295, $39F0, $18C7, $0863, $318D, $56B5, $39F0, $18C7, $294B, $5295, $18A6, $5AD7, $7BFE, $7BBD, $6B5A, $14C5, $1084
@@DATA000118:
	dw   $0842, $14C5, $14C5, $14C5, $2949, $2D6B, $294A, $20E8, $1CC6, $14C5, $18C7, $294B, $4A74, $0CE8, $0465, $0465, $0CEA, $156F, $1D70, $156F, $156F, $25B3, $156F, $156F, $1D70, $0CEA, $0465, $0C85, $294B, $5F18, $77BD, $7BFE, $7FFF, $7BDE, $737C, $1CC6
@@DATA000119:
	dw   $1CC6, $6739, $7FFF, $7FFF, $7FFF, $7BFE, $77BD, $5AD7, $2D6B, $1D08, $1CE7, $1084, $35AE, $39F0, $31AD, $18C7, $4A74, $4A33, $18C7, $737C, $7BDE, $7BDE, $318D, $1D08, $2D6B
@@DATA000120:
	dw   $0C63, $1CC7, $1CE7, $14C5, $2949, $2D6B, $294A, $20E8, $1CC7, $14C5, $18C7, $31AD, $52B6, $0C64, $0843, $0C85, $0CE8, $150B, $1D2C, $216E, $21B1, $156F, $1172, $156F, $08EB, $0465, $1D2C, $39F0, $56B5, $739C, $7BDE, $7FFF, $7FFF, $7FFF, $7FFF, $2D6B
@@DATA000121:
	dw   $18A5, $20E8, $7BDE, $7FFF, $7FFF, $7FFF, $77BD, $41F0, $2529, $56B5, $0863, $0863, $18C7, $2529, $318D, $35AE, $5295, $41F0, $14A5, $5F18, $7BBD, $5293, $14C5
@@DATA000122:
	dw   $18C7
@@DATA000123:
	dw   $14A5, $14C5, $18C7, $1CC6, $2D48, $356A, $2D6B, $2509, $18C7, $14C5, $14C5, $318D, $5295, $0843, $0C63, $1064, $1D29, $52B6, $52B6, $35F1, $150B, $0CEA, $216E, $150B, $0CE8, $52B6, $5295, $5295, $5AD7, $739C, $7FFF, $7FFF, $7FFF, $7FFF, $77BD, $4631
@@DATA000124:
	dw   $1CC6, $5293, $7FFF, $7FFF, $7BFE, $4631, $294B, $739C, $294A, $0863, $18C7, $4A74, $52B6, $5295, $5295, $4E74, $39F0, $1064, $14A6, $41F0, $0843, $18C7
@@DATA000125:
	dw   $14A6
@@DATA000126:
	dw   $1064, $1CC7, $1CC7, $1CC7, $2949, $2D6B, $2529, $1D08, $18C7, $18C7, $1CE7, $2D6B, $5674, $0821, $0821, $0863, $14A5, $39F0, $5295, $5295, $5295, $4E74, $1D2C, $216E, $52B6, $5295, $5295, $5295, $5AD6, $7BFE, $7FFF, $7FFF, $7FFF, $7FFF, $7BFE, $5F18
@@DATA000127:
	dw   $1CE7, $41CF, $7BBD, $7BDD, $5AF8, $1CC6, $41CF, $39AD, $14C5, $14C5, $52B6, $5AD7, $4E94, $5295, $5295, $5295, $35AE, $18A6, $2529, $1064, $1064
@@DATA000128:
	dw   $1042, $28E8, $18A5, $1CC7, $2949, $2D6B, $294B, $2509, $18C7, $18C7, $14C5, $2D6B, $5674, $0821, $0000, $0421, $1084, $1064, $5295, $5295, $5295, $52B6, $4EB7, $52B6, $5295, $5295, $5295, $56D7, $6B7B, $7BFE, $7FFF, $7FFF, $7FFF, $7FFF, $7BFE, $7BBD
@@DATA000129:
	dw   $1CC6, $4A31, $39CE, $14A5, $1CC6, $0C63, $2D6B, $5295, $2D6B, $77BD, $7BBD, $6B7B, $5F18, $5AD7, $5ED7, $20E8, $294A
@@DATA000130:
	dw   $18C7, $18C7, $0821, $39AD, $41CF, $1CC7, $2D29, $2D6B, $294A, $20E8, $1CC7, $1CC6, $1CC4, $39AD, $62D5, $0821, $0842, $18C7
@@DATA000131:
	dw   $0C64, $35AE, $5295, $5295, $5295, $5295, $5295, $5295, $52B6, $56D7, $6B5A, $7BFE, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $77BD
@@DATA000132:
	dw   $1CA4, $1483, $0821, $0843, $39AD, $56B5, $7FDF, $4210, $41F0, $7BDE, $7FFF, $7BFE, $7BDD, $7BBD, $5293, $0821
@@DATA000133:
	dw   $1D08, $14A6, $0842, $0842, $2927, $2D48, $356B, $41CD, $41CD, $41CB, $2D48, $356B, $2D48, $3569, $4A2F, $5AD6, $0421, $0843
@@DATA000134:
	dw   $1064, $4A74, $5295, $5295, $5295, $5295, $5295, $4E74, $5F18, $77BD, $7BDE, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $739C
@@DATA000135:
	dw   $1042, $0821, $5674, $7BDE, $7BFF, $77BD, $2529, $739C, $7FFF, $7FFF, $7BFE, $7BBD, $4230, $1CC5, $1483
@@DATA000136:
	dw   $0842, $2529, $0421, $0842, $1CC5, $2D48, $2D48, $2927, $356B, $3569, $2927, $2D48, $2927, $45CE, $45CE, $5293, $1064, $1064
@@DATA000137:
	dw   $14A6, $2509, $4E94, $5295, $5295, $5295, $5295, $5F18, $739C, $7BFE, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $4631
@@DATA000138:
	dw   $1CC6, $356B, $7BDE, $7FFF, $7FFF, $6739, $2D6B, $7BFF, $7FFF, $7FFF, $6F39, $2D48, $1CA4, $1042
@@DATA000139:
	dw   $1084, $318D, $0421, $1084, $1CC6, $1CE7, $35AB, $2D29, $356B, $2D48, $24C6, $24C6, $2D48, $2D48, $35AB, $5293, $14A6, $1064
@@DATA000140:
	dw   $0C64, $2D6B, $4E94, $52B6, $5295, $56D7, $6B7B, $77BE, $7BFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7BDE, $7FFF, $14A6, $18C7
@@DATA000141:
	dw   $1CC6, $5AB4, $7BBD, $7FDF, $7FFF, $5ED7, $39F0, $7BDE, $7FFF, $7BDE, $2506, $1020
@@DATA000142:
	dw   $294B, $2529, $39CE, $0421, $14A5, $18C7, $1CE7, $1CC5, $41CD, $41CD, $356B, $356B, $356B, $2506, $1CC5, $356B, $5AD6, $2528, $1064, $0421
@@DATA000143:
	dw   $0C64, $294B, $5AF8, $52B6, $5F3B, $77BE, $7FFF, $7FFF, $7FFF, $7BFE, $7BFE, $7FFF, $7FFF, $7BFE, $5AD7, $0C64
@@DATA000144:
	dw   $20E8, $41CF, $7BBD, $7FDF, $7FFF, $6739, $4A74, $7FFF, $7FFF, $41CD, $1020
@@DATA000145:
	dw   $1084, $35AE, $39CE, $0C63, $1483, $1CC5, $1CC5, $2506, $2D48, $41CB, $41CD, $41CD, $2D48, $24C6, $24C5, $2D48, $41CD, $1CC5, $294B, $0421
@@DATA000146:
	dw   $0C64, $1CE7, $6739, $77BD, $7BDE, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7BFF, $77BD, $18C7, $1064
@@DATA000147:
	dw   $1CC6, $5AB4, $7FFF, $7FFF, $7FFF, $7FDF, $7FFF, $7BBD, $1042, $24C6
@@DATA000148:
	dw   $0842, $39F0, $2D6B, $1063, $1063, $2927, $41CD, $356B, $41CD, $41CB, $2D48, $2905, $2D48, $3569, $3569, $45CE, $2506, $1CC4, $5AD7, $1084
@@DATA000149:
	dw   $0C64, $14A6, $66F8, $7BBD, $7FDF, $7FDF, $7FFF, $7FFF, $7BFE, $7FFF, $77BE, $318D, $0C64
@@DATA000150:
	dw   $1CC6, $56B5, $7BFF, $7FFF, $7FFF, $7FFF, $6F39, $1042
@@DATA000151:
	dw   $0842, $41F0, $4A74, $1CC7, $1CE7, $1042, $1CA4, $356A, $356A, $356A, $2D48, $24C5, $24C3, $2905, $3DAA, $24C6, $1460, $2927, $5AB4, $0842
@@DATA000152:
	dw   $1CC5, $0C64, $1CC6, $5293, $6F39, $7BDD, $7FDF, $7BDE, $77BD, $294B, $0C64
@@DATA000153:
	dw   $1CC6, $56B5, $7BFE, $7FFF, $7FFF, $4A2F, $1020
@@DATA000154:
	dw   $0842, $39F0, $4E74, $2529, $1CC6, $1CC7, $0821, $1483, $2927, $41CD, $41CD, $41CD, $45CE, $41CD, $1CC5, $1460, $1063, $4A2F, $5271, $0842
@@DATA000155:
	dw   $1064, $0863, $0C64, $0C64, $1064, $1064, $0C64, $1084
@@DATA000156:
	dw   $1CC6, $5271, $7BBD, $735A, $1020, $1063
@@DATA000157:
	dw   $0843, $4A74, $4E74, $5295, $2529, $1CE8, $1D08, $14A5, $0C63, $1CC6, $2506, $1CC5, $1483, $0821, $0842, $1483, $4631, $7BBD, $4631, $1064
@@DATA000158:
	dw   $1CC6, $35AB, $5293, $1020
@@DATA000159:
	dw   $0843, $4E94, $5295, $5295, $5295, $31AD, $1D08, $2529, $18C7, $0421, $0843, $1063, $1084, $14C5, $2528, $6739, $7BDE, $7BBD, $294B, $18C7
@@DATA000160:
	dw   $1CC6, $0821, $0821
@@DATA000161:
	dw   $0843, $4233, $5295, $5295, $5295, $5295, $4E94, $4231, $318D, $318D, $318D, $39CE, $4231, $5AD7, $7BFF, $77BE, $77BE, $6B7B, $0C64
@@DATA000162:
	dw   $0842, $39F0, $52B6, $5295, $5295, $5295, $5295, $52B6, $52B6, $5295, $56B5, $6B7B, $77BE, $77BE, $77BE, $7BFF, $77BE, $56D7, $0465
@@DATA000163:
	dw   $0842, $31AD, $4E74, $5295, $5295, $5295, $5295, $5295, $52B6, $56B5, $5F18, $739C, $77BE, $7FFF, $7FFF, $7FFF, $7BFF, $4231, $0465
@@DATA000164:
	dw   $0842, $294B, $5295, $5295, $5295, $5295, $5295, $5295, $5AD7, $6B5A, $77BD, $7BFE, $7FFF, $7FFF, $7FFF, $7FFF, $6B5A, $0C64
@@DATA000165:
	dw   $0863, $0C64, $4E94, $4E74, $5295, $5295, $52B6, $5AD7, $6B5A, $77BD, $7FDF, $7FFF, $7FFF, $7FFF, $7FFF, $7BDE, $358D, $18A6
@@DATA000166:
	dw   $0C64, $4231, $5295, $5295, $52B6, $5AD7, $6B5A, $77BD, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FDF, $5674, $18A5
@@DATA000167:
	dw   $0C64, $4A33, $56D7, $5F18, $6B9C, $77BE, $7FDF, $7FFF, $7FFF, $7FFF, $7FFF, $7BDE, $77BD, $1CE8, $2529
@@DATA000168:
	dw   $0C63, $18C7, $5AF8, $6B7B, $77BE, $7BFF, $7FFF, $7FFF, $7FFF, $7FFF, $7BFF, $77BE, $358D, $14A6
@@DATA000169:
	dw   $0C63, $2D6B, $77BE, $7BFF, $7BFF, $7BFF, $7FFF, $7BFE, $7FFF, $7BBD, $56B5, $0C64
@@DATA000170:
	dw   $0C63, $2529, $737C, $7BBD, $7FFF, $7BFE, $7BDD, $77BD, $5293, $0C63
@@DATA000171:
	dw   $1CE7, $0863, $2D6B, $358D, $5293, $358D, $1042, $1042
end;

end.
